//-----------------------------------------------------------------------------
// File: ExGrid2.cs
//
// Starting point for new Direct3D applications
//
// Copyright (c) Microsoft Corporation. All rights reserved.
//-----------------------------------------------------------------------------


/*
'06.01.28쐬
	Microsoft DirectX SDK (December 2005)
	EmptyProject쐬

	ȉ

	1.ACR\
	public void CreateWindow(string windowTitle, System.Drawing.Icon icon, System.Windows.Forms.MainMenu menu, int x, int y) ɂ
		renderWindow.Icon = icon;	// ǉ!!

	2._VF[_ fobO
	public void ModifyDeviceSettings(DeviceSettings settings, Caps caps) ɂ
		settings.BehaviorFlags &= ~CreateFlags.PureDevice;	// ǉ:_VF[_̃fobO\ƂȂ
 */


// ppp = EmptyProject ɒǉӏ


//#define DEBUG_VS	// Uncomment this line to debug vertex shaders 
//#define DEBUG_PS	// Uncomment this line to debug pixel shaders 
/*
!! _VF[_(vertex shaders)̃fobO͈ȉ̍sǉ
settings.BehaviorFlags &= ~CreateFlags.PureDevice;	// ǉ:_VF[_̃fobO\ƂȂ
*/


using System;
using System.Collections;

using Microsoft.DirectX;
using Microsoft.DirectX.Direct3D;
using Microsoft.Samples.DirectX.UtilityToolkit;

using Direct3D=Microsoft.DirectX.Direct3D;

// j[.vWFNg.QƂ̒ǉsystem.xml.dllǉ
using System.Xml;


namespace ExGrid2Sample
{
    /// <summary>ExGrid2 Sample Class</summary>
	public class ExGrid2 : IFrameworkCallback, IDeviceCreation
	{
		#region Creation
		/// <summary>Create a new instance of the class</summary>
		public ExGrid2(Framework f) 
		{ 
			// Store framework
			sampleFramework = f; 
			// Create dialogs
			hud				= new Dialog(sampleFramework); 
			sampleUi		= new Dialog(sampleFramework); 
			this.AIvsAIUi	= new Dialog(sampleFramework); 
		}
		#endregion

		// constants
		private static readonly ColorValue WhiteColor  = new ColorValue(1.0f,1.0f,1.0f,1.0f);
		private static readonly ColorValue YellowColor = new ColorValue(1.0f,1.0f,0.0f,1.0f);

		// ppp
		//		private	Board	board		= null;
		private volatile Board board = null;


		// Variables
		private Framework sampleFramework = null; // Framework for samples

		private Font statsFont	= null; // Font for drawing text
		private Font firstFont	= null;	// bZ[W\ptHg


		private Sprite textSprite = null; // Sprite for batching text calls

		// sss hlsl/VF[_[
		private Effect effect = null; // D3DX Effect Interface

		private ModelViewerCamera	camera = new ModelViewerCamera(); // A model viewing camera

		private bool isHelpShowing = false; // If true, renders the UI help text


		private Dialog hud		= null;	// dialog for standard controls
		private Dialog sampleUi = null;	// dialog for sample specific controls
		private Dialog AIvsAIUi = null;	// AIvsAIis`FbN{bNX


		// HUD Ui Control constants
		private const int ToggleFullscreen = 1;
		private const int ToggleReference = 3;
		private const int ChangeDevice = 4;

		// }EX J[\ʒu
		private	short	mouseX		=  0;
		private	short	mouseY		=  0;

		private	int		windowWidth;
		private	int		windowHeight;

		private	int		pickedEdgeX = 0;
		private	int		pickedEdgeY = 0;
		private	int		pickedEdgeZ = 0;

		// }EXI[oObh
		private	int		mouseOverX = 0;
		private	int		mouseOverY = 0;
		private	int		mouseOverZ = 0;

		private	bool	bMouseLeftButtonDown = false;

		// vC[ l/\tg
		private	Player[]	player = new Player[2];
		private	int			current_player = 0;	// ݂̃vC[

		private	float Jlen = 5.0f;	// L[͂ɂύXJƕ`撆SԂ̋

		// ݒ_CAO\p
		private	Config	Config = null;

		private enum ApplicationState
		{
			Config,
			RenderScene
		};

		private ApplicationState	applicationState = ApplicationState.RenderScene; // State of the application

		public	ConfigDat	ConfigDat = new ConfigDat();

		// fps
		private float		m_f`掞 = 0.0f;

		// XML DOM READ 菇t@Cǂݍݗp
		public	XmlDocument m_doc;		// DOM hLg

		public	XmlNodeList	m_nodeList;	// DOM m[hXg

		public	XmlNode		m_Node;		// DOM m[hXg


		// AIvsAI Q[is
		private bool		bQ[is		= false;
		private	bool		b}EXNbN = false;

		private bool		bW\		= false;
		
		private	string		ErrMsg = null;	// OG[bZ[W


#if(DEBUG)
		// debugp Ďs 
		private	int	debugJE^ = 1;	// Q[
		private	int	errJE^ = 0;	// O
#endif


		// Light stuff (Widget EBWbg)
		DirectionWidget	CgRg[ = new DirectionWidget();	// CgRg[(\p)

		// wiFݒ
		private int icol	= 0x00010601;
		private int icolW	= 16;
		private int icol		= 0x00106010;

		private bool	bFirstRun	= true;	// Nconfigt@C̓eɂQ[ݒ


		// sbNA}EXI[oop
		private	Matrix		projMat		= Matrix.Identity;	// es
		private	Matrix		viewMat		= Matrix.Identity;	// r[s
		private	Matrix		worldMat	= Matrix.Identity;	// [hs	

		/// <summary>
		/// Called during device initialization, this code checks the device for some 
		/// minimum set of capabilities, and rejects those that don't pass by returning false.
		/// </summary>
		public bool IsDeviceAcceptable(Caps caps, Format adapterFormat, Format backBufferFormat, bool windowed)
		{
			// Skip back buffer formats that don't support alpha blending
			if (!Manager.CheckDeviceFormat(caps.AdapterOrdinal, caps.DeviceType, adapterFormat, 
				Usage.QueryPostPixelShaderBlending, ResourceType.Textures, backBufferFormat))
				return false;

			return true;
		}

		/// <summary>
		/// This callback function is called immediately before a device is created to allow the 
		/// application to modify the device settings. The supplied settings parameter 
		/// contains the settings that the framework has selected for the new device, and the 
		/// application can make any desired changes directly to this structure.  Note however that 
		/// the sample framework will not correct invalid device settings so care must be taken 
		/// to return valid device settings, otherwise creating the Device will fail.  
		/// </summary>
		public void ModifyDeviceSettings(DeviceSettings settings, Caps caps)
		{
			// If device doesn't support HW T&L or doesn't support 1.1 vertex shaders in HW 
			// then switch to SWVP.
			if ( (!caps.DeviceCaps.SupportsHardwareTransformAndLight) ||
				(caps.VertexShaderVersion < new Version(1,1)) )
			{
				settings.BehaviorFlags = CreateFlags.SoftwareVertexProcessing;
			}
			else
			{
				settings.BehaviorFlags = CreateFlags.HardwareVertexProcessing;
			}

			// This application is designed to work on a pure device by not using 
			// any get methods, so create a pure device if supported and using HWVP.
			if ( (caps.DeviceCaps.SupportsPureDevice) && 
				((settings.BehaviorFlags & CreateFlags.HardwareVertexProcessing) != 0 ) )
				settings.BehaviorFlags |= CreateFlags.PureDevice;

			// Debugging vertex shaders requires either REF or software vertex processing 
			// and debugging pixel shaders requires REF.  
#if(DEBUG_VS)
            if (settings.DeviceType != DeviceType.Reference )
            {
                settings.BehaviorFlags &= ~CreateFlags.HardwareVertexProcessing;
				settings.BehaviorFlags &= ~CreateFlags.PureDevice;	// ǉ:_VF[_̃fobO\ƂȂ
				settings.BehaviorFlags |= CreateFlags.SoftwareVertexProcessing;
            }
#endif
#if(DEBUG_PS)
            settings.DeviceType = DeviceType.Reference;
#endif
			// For the first device created if its a REF device, optionally display a warning dialog box
			if (settings.DeviceType == DeviceType.Reference)
			{
				Utility.DisplaySwitchingToRefWarning(sampleFramework, "ExGrid2");
			}

		}

		/// <summary>
		/// This event will be fired immediately after the Direct3D device has been 
		/// created, which will happen during application initialization and windowed/full screen 
		/// toggles. This is the best location to create Pool.Managed resources since these 
		/// resources need to be reloaded whenever the device is destroyed. Resources created  
		/// here should be released in the Disposing event. 
		/// </summary>
		private void OnCreateDevice(object sender, DeviceEventArgs e)
		{
			// Initialize the stats font
			statsFont = ResourceCache.GetGlobalInstance().CreateFont(
				e.Device,
				15,	// tHgTCY?c
				0,	// tHgTCY?
				FontWeight.Bold,
				1,
				false,
				CharacterSet.Default,
				Precision.Default,
				FontQuality.Default,
				PitchAndFamily.FamilyDoNotCare | PitchAndFamily.DefaultPitch,
				"Arial");

			firstFont = new Font(
				e.Device,
				22,			// 
				0,
				FontWeight.Bold,
				1,
				false,
				CharacterSet.Default,
				Precision.Default,
				FontQuality.Default, 
				PitchAndFamily.DefaultPitch | PitchAndFamily.FamilyDoNotCare,
				"Arial");	// fontName


			// Define DEBUG_VS and/or DEBUG_PS to debug vertex and/or pixel shaders with the 
			// shader debugger. Debugging vertex shaders requires either REF or software vertex 
			// processing, and debugging pixel shaders requires REF.  The 
			// ShaderFlags.Force*SoftwareNoOptimizations flag improves the debug experience in the 
			// shader debugger.  It enables source level debugging, prevents instruction 
			// reordering, prevents dead code elimination, and forces the compiler to compile 
			// against the next higher available software target, which ensures that the 
			// unoptimized shaders do not exceed the shader model limitations.  Setting these 
			// flags will cause slower rendering since the shaders will be unoptimized and 
			// forced into software.  See the DirectX documentation for more information about 
			// using the shader debugger.
			ShaderFlags shaderFlags = ShaderFlags.NotCloneable;
#if(DEBUG_VS)
            shaderFlags |= ShaderFlags.ForceVertexShaderSoftwareNoOptimizations;
#endif
#if(DEBUG_PS)
            shaderFlags |= ShaderFlags.ForcePixelShaderSoftwareNoOptimizations;
#endif

			// sss
			// Read the D3DX effect file
			string path = Utility.FindMediaFile("ExGrid2.fx");
			effect = ResourceCache.GetGlobalInstance().CreateEffectFromFile(e.Device,
				path, null, null, shaderFlags, null);

			// Setup the camera's view parameters
			camera.SetViewParameters( new Vector3(0.0f, 0.0f, -5.0f), Vector3.Empty);	// J ʒu ړ_
			camera.SetRadius( 5.0f, 1.0f, 512.0f );	// J̋ default,min,max

			// Setup direction widget
			DirectionWidget.OnCreateDevice(e.Device);
			CgRg[.Radius = 5.0f;	// aݒ

		}

		

		
		

		
		/// <summary>
		/// This event will be fired immediately after the Direct3D device has been 
		/// reset, which will happen after a lost device scenario. This is the best location to 
		/// create Pool.Default resources since these resources need to be reloaded whenever 
		/// the device is lost. Resources created here should be released in the OnLostDevice 
		/// event. 
		/// </summary>
		private void OnResetDevice(object sender, DeviceEventArgs e)
		{
			SurfaceDescription desc = e.BackBufferDescription;
			// Create a sprite to help batch calls when drawing many lines of text
			textSprite = new Sprite(e.Device);

			// Setup the camera's projection parameters
			float aspectRatio = (float)desc.Width / (float)desc.Height;
			camera.SetProjectionParameters( (float)Math.PI / 4, aspectRatio, 1.0f, 512.0f );
			camera.SetWindow(desc.Width, desc.Height);

			windowWidth		= desc.Width;
			windowHeight	= desc.Height;


			camera.SetButtonMasks(	
				(int)MouseButtonMask.Right,		// rotateModel	E
				(int)MouseButtonMask.Wheel,		// zoom			zC[]
				(int)MouseButtonMask.None);		// rotateCamera	


			// ppp
			// Set device transforms
			// (HLSLgpȂ\̏ꍇɕKv)
//			e.Device.Transform.Projection = camera.ProjectionMatrix;

			// Setup UI locations
			hud.SetLocation( desc.Width-170, 0 );
			hud.SetSize( 170,170 );

			sampleUi.SetLocation( desc.Width-170, desc.Height - 350 );
			sampleUi.SetSize( 170,300 );

			AIvsAIUi.SetLocation( desc.Width-170, desc.Height - 250 );
			AIvsAIUi.SetSize( 170,300 );


			// JOItɂāA[U[ɎOp`̑OʂƔwʂ悤ɂ܂B
			e.Device.RenderState.CullMode = Cull.None;

			e.Device.RenderState.Lighting = false;

			// ArGg I
			// ArGǵAgUAׂẴIuWFNglɏƂ炷CgB
//			e.Device.RenderState.Ambient = System.Drawing.Color.FromArgb(0x808080);

			// Nconfigt@C̓eɂQ[ݒ
			if( this.bFirstRun )
			{
				this.bFirstRun = false;
				this.GAMEݒ(e.Device);
			}
			else
			{
				// Nȍ~AEBhETCYXVɎs
				this.board.CreateVB( e.Device );
			}

			// Restore the fonts / sprite
			firstFont.OnResetDevice();

			// Reset items
			CgRg[.OnResetDevice(desc);

			// }EX̂ǂ̃{^ŃCg]邩w
			CgRg[.RotateButtonMask = MouseButtonMask.Middle;

		}










		/// <summary>
		/// This event function will be called fired after the Direct3D device has 
		/// entered a lost state and before Device.Reset() is called. Resources created
		/// in the OnResetDevice callback should be released here, which generally includes all 
		/// Pool.Default resources. See the "Lost Devices" section of the documentation for 
		/// information about lost devices.
		/// </summary>
		private void OnLostDevice(object sender, EventArgs e)
		{
			if (textSprite != null)
			{
				textSprite.Dispose();
				textSprite = null;
			}

			// ppp
			if ( this.board != null)
			{
				this.board.Dispose();
			}

			if (firstFont != null)
				firstFont.OnLostDevice();

			// Update the direction widget
			DirectionWidget.OnLostDevice();

		}




		/// <summary>
		/// This callback function will be called immediately after the Direct3D device has 
		/// been destroyed, which generally happens as a result of application termination or 
		/// windowed/full screen toggles. Resources created in the OnCreateDevice callback 
		/// should be released here, which generally includes all Pool.Managed resources. 
		/// </summary>
		private void OnDestroyDevice(object sender, EventArgs e)
		{
			if (firstFont != null)
			{
				firstFont.Dispose();
				firstFont = null;

				// -------------------------------------------
				// Q[ݒ̕ۑ"ExGrid2.config"
				try 
				{
					/*
					XMLt@Cɏ܂vf́ApubNołtB[hƃvpeBłB

					ɁAǂݍ݁A邢͏݂ĂȂvpeB́A
					pubNołĂ܂܂B

					܂AVAIuWFNg̃NXɂ́A
					K̃RXgN^iȂRXgN^jKvłB
					*/

					//ۑ̃t@C (exẽtpX擾ÃfBNg𓾂)
					string	fileName =	System.IO.Path.GetDirectoryName( System.Windows.Forms.Application.ExecutablePath )
										+ "\\" + "ExGrid2.config";

					//XMLt@Cɏށ
					//XmlSerializerIuWFNg쐬
					//ރIuWFNǧ^w肷
					System.Xml.Serialization.XmlSerializer	serializer1 =
						new System.Xml.Serialization.XmlSerializer( typeof(ConfigDat) );

					//t@CJ
					System.IO.FileStream	fs1 =
						new System.IO.FileStream( fileName, System.IO.FileMode.Create );

					//VAAXMLt@Cɕۑ
					serializer1.Serialize( fs1, ConfigDat );

					//
					fs1.Close();
				}
				catch
				{
					// OA܂Ȃ
				} 
				// -------------------------------------------
			
			
			
			}

			// Update the direction widget
			DirectionWidget.OnDestroyDevice();

		}

		/// <summary>
		/// This callback function will be called once at the beginning of every frame. This is the
		/// best location for your application to handle updates to the scene, but is not 
		/// intended to contain actual rendering calls, which should instead be placed in the 
		/// OnFrameRender callback.  
		/// </summary>
		public void OnFrameMove( Device device, double appTime, float elapsedTime )
		{
			// Update the camera's position based on user input 
			camera.FrameMove( elapsedTime );

			// ppp
			// [hs r[sݒ
			// (HLSLgpȂ\̏ꍇɕKv)
//			device.Transform.World	= camera.WorldMatrix;
//			device.Transform.View	= camera.ViewMatrix;

			projMat		= camera.ProjectionMatrix;	// es
			viewMat		= camera.ViewMatrix;		// r[s
			worldMat	= camera.WorldMatrix;		// [hs	

			// }EXI[oObȟo
			Movable}EXI[oo();

			// }EX ENbNo
			if( camera.IsMouseLeftButtonDown )
			{
				if( !bMouseLeftButtonDown )
				{
					MovablesbNo();	// ΂łĂObĥ݂Ώ
				}
				bMouseLeftButtonDown = true;
			}
			else
			{
				bMouseLeftButtonDown = false;
			}
		}




		/// <summary>
		/// This callback function will be called at the end of every frame to perform all the 
		/// rendering calls for the scene, and it will also be called if the window needs to be 
		/// repainted. After this function has returned, the sample framework will call 
		/// Device.Present to display the contents of the next buffer in the swap chain
		/// </summary>
//		public void OnFrameRender(Device device, double appTime, float elapsedTime)
		public unsafe void OnFrameRender(Device device, double appTime, float elapsedTime)
		{
			// ݒ_CAO\
			switch( applicationState )
			{
				// ----------------------------------------------------
				// Q[ݒ_CAO
				case ApplicationState.Config:
				{
//					bool Result;	// _CAO ok ̏ꍇ true
					System.Windows.Forms.DialogResult	Result;

					applicationState = ApplicationState.RenderScene;

					// tXN[łꍇAꎞB
					if( !sampleFramework.IsWindowed )
					{
						sampleFramework.ToggleFullscreen();

						// Q[ݒ_CAO --------------------tXN[
						Result = this.Config.Open( this );
						if( System.Windows.Forms.DialogResult.OK == Result )
						{
							this.GAMEݒ( device );
						}
						else if( System.Windows.Forms.DialogResult.No == Result )
						{
							this.XMLLoad( device ); // 菇t@C[h
						}
						sampleFramework.ToggleFullscreen();
					}
					else
					{
						// Q[ݒ_CAO --------------------EBhE
						Result = this.Config.Open( this );
						if( System.Windows.Forms.DialogResult.OK == Result )
						{
							this.GAMEݒ( device );
						}
						else if( System.Windows.Forms.DialogResult.No == Result )
						{
							this.XMLLoad( device ); // 菇t@C[h
						}
					}
				}
				break;
			}


			// ----------------------------------------
			// l/AI vC[

			// vC[^Cv擾(Undỏ񐔔p)
			string	Type;
			if( 0 == current_player )
				Type = this.player[ 1 ].getType();
			else
				Type = this.player[ 0 ].getType();

			// AIvsAIAAbQ[isfalsȅꍇA}EXNbNOnTurnsB
			if( ("AI vs AI" == this.ConfigDat.vC[^Cv) && !this.bQ[is  )
			{
				// }EX ENbNoA܂́Aundȍꍇ
				if( camera.IsMouseLeftButtonDown || (-2 == pickedEdgeX && -2 == pickedEdgeY && -2 == pickedEdgeZ) )
				{
					if( !this.b}EXNbN )
					{
						// OnTurn\bh
						//	false:AIvC[Xbhōl(vC[sȂB)
						//	ture :ȊO
						if( this.player[ current_player ].OnTurn( this.board, pickedEdgeX, pickedEdgeY, pickedEdgeZ, Type ) )
						{
							// vC[(board̃JgJ[𔽉fAۂɂ͕ςȂꍇL)
							if( Disc. == this.board.getCurrentColor() )
								current_player = 0;
							else
								current_player = 1;

							this.b}EXNbN = true;	// XbhIŎOnTurns
						}
					}
				}
				else
				{
					this.b}EXNbN = false;
				}
			}
			else
			{
				// OnTurn\bh
				//	false:AIvC[Xbhōl(vC[sȂB)
				//	ture :ȊO
				if( this.player[ current_player ].OnTurn( this.board, pickedEdgeX, pickedEdgeY, pickedEdgeZ, Type ) )
				{
					// vC[(board̃JgJ[𔽉fAۂɂ͕ςȂꍇL)
					if( Disc. == this.board.getCurrentColor() )
						current_player = 0;
					else
						current_player = 1;
				}
			}

			// }EX sbNW 
			this.pickedEdgeX = -1;
			this.pickedEdgeY = -1;
			this.pickedEdgeZ = -1;
			// ----------------------------------------


			// -------------------------------------------------------------------------
			// fps 60fps
			// memo:tXN[fpsRefresh RateɈˑB
			float	f = (float)FrameworkTimer.GetTime();
			if( f < m_f`掞 )
			{
				System.Threading.Thread.Sleep( (int)( ( m_f`掞 - f ) * 1000 ) );	// ~bP
			}
			m_f`掞 = (float)FrameworkTimer.GetTime() + 0.0167f;	// 16.7ms  1/60sec	// bP


			// -------------------------------------------------------------------------
			bool beginSceneCalled = false;

			// Clear the render target and the zbuffer 
//                                                                                   rrggbb
//			device.Clear( ClearFlags.ZBuffer | ClearFlags.Target, unchecked((int)0x00106010), 1.0f, 0 );
			device.Clear( ClearFlags.ZBuffer | ClearFlags.Target, icol, 1.0f, 0 );


			try
			{
				device.BeginScene();
				beginSceneCalled = true;


				// }EX ~h(zC[)NbNo
				if( camera.IsMouseMiddleButtonDown )
				{
					// Render the arrows so the user can visually see the light direction
					// Cg\\
					device.RenderState.FillMode = FillMode.Solid;
					CgRg[.OnRender( YellowColor, camera.ViewMatrix, camera.ProjectionMatrix, camera.EyeLocation );
				}

				Vector3	Cg = CgRg[.LightDirection;

				// Update the effects now
				// [hԂł̌̕
				effect.SetValue( "g_LightDir", &Cg, sizeof(Vector3));


				// Update the effect's variables.  Instead of using strings, it would 
				// be more efficient to cache a handle to the parameter by calling 
				// Effect.GetParameter
				Matrix	worldViewProjection = camera.WorldMatrix * camera.ViewMatrix * camera.ProjectionMatrix;

				effect.SetValue( "worldViewProjection",	worldViewProjection );
				effect.SetValue( "worldMatrix",			camera.WorldMatrix );
				effect.SetValue( "g_Len",				camera.ViewMatrix.M43 );

				// HLSLgp
				this.board.Draw(	device,
									camera.WorldMatrix, worldViewProjection,
									mouseOverX, mouseOverY, mouseOverZ,
									effect, bW\ );	//s

				// Show frame rate
				RenderText();


				// Show UI
				hud.OnRender(elapsedTime);
				sampleUi.OnRender(elapsedTime);
				AIvsAIUi.OnRender(elapsedTime);


			}

#if(DEBUG)
			catch (Exception e)
			{
				System.Threading.Thread.Sleep( 1000 ); // 1bقǋxł݂B

				// AI vs AI ŃQ[isꍇ:~
/*
				if( true == bQ[is )
				{
					AIvsAIUi.GetCheckbox( ChangeDevice + 30 ).IsChecked = false;
					this.bQ[is = false;
				}
*/
				this.ErrMsg = null;
				this.errJE^++;
				this.ErrMsg = "DirectXO:" + e.Message + "s:" + this.debugJE^.ToString()+"O"+this.errJE^.ToString();
#else
			catch
			{
				System.Threading.Thread.Sleep( 1000 ); // 1bقǋxł݂B
#endif

			}
			finally
			{
				if (beginSceneCalled)
					device.EndScene();
			}
		}






















		/// <summary>
		/// Render the help and statistics text. This function uses the Font object for 
		/// efficient text rendering.
		/// </summary>
		private void RenderText()
		{
			TextHelper txtHelper = new TextHelper( statsFont, textSprite, 15 );	// 15:s?

			// Output statistics
			txtHelper.Begin();
			txtHelper.SetInsertionPoint(5,5);

			if ( isHelpShowing )
			{
				txtHelper.SetForegroundColor(System.Drawing.Color.Yellow);
				txtHelper.DrawTextLine(sampleFramework.FrameStats);
				txtHelper.DrawTextLine(sampleFramework.DeviceStats);
			}
			

			if( 6 == this.board.iRULE )
			{
				txtHelper.SetForegroundColor(System.Drawing.Color.DarkOrange );
				txtHelper.DrawTextLine("͂߂ : ΂ߖ( 6)");
			}
			else
			{
				txtHelper.SetForegroundColor(System.Drawing.Color.Yellow );
				txtHelper.DrawTextLine("͂߂ : ΂ߗL(26)");
			}


			txtHelper.SetForegroundColor(System.Drawing.Color.White);
//			txtHelper.DrawTextLine("Put some status text here.");

/*
			// }EX J[\ʒu \
			txtHelper.DrawTextLine( mouseX.ToString() );
			txtHelper.DrawTextLine( mouseY.ToString() );
*/

/*
			// }EX ENbNo
			if( camera.IsMouseLeftButtonDown )
			{
				txtHelper.DrawTextLine("Left Down");
			}
			else
			{
				txtHelper.DrawTextLine("Left Up");
			}
*/



/*
			Matrix	m	= new Matrix();
			txtHelper.DrawTextLine("WorldMatrix");
			m = camera.WorldMatrix;
			txtHelper.DrawTextLine( String.Format("m:{0,7:F4},{1,7:F4},{2,7:F4},{3,7:F4}", m.M11, m.M12, m.M13, m.M14) );
			txtHelper.DrawTextLine( String.Format("m:{0,7:F4},{1,7:F4},{2,7:F4},{3,7:F4}", m.M21, m.M22, m.M23, m.M24) );
			txtHelper.DrawTextLine( String.Format("m:{0,7:F4},{1,7:F4},{2,7:F4},{3,7:F4}", m.M31, m.M32, m.M33, m.M34) );
			txtHelper.DrawTextLine( String.Format("m:{0,7:F4},{1,7:F4},{2,7:F4},{3,7:F4}", m.M41, m.M42, m.M43, m.M44) );

			txtHelper.DrawTextLine("ViewMatrix");
			m = camera.ViewMatrix;
			txtHelper.DrawTextLine( String.Format("m:{0,7:F4},{1,7:F4},{2,7:F4},{3,7:F4}", m.M11, m.M12, m.M13, m.M14) );
			txtHelper.DrawTextLine( String.Format("m:{0,7:F4},{1,7:F4},{2,7:F4},{3,7:F4}", m.M21, m.M22, m.M23, m.M24) );
			txtHelper.DrawTextLine( String.Format("m:{0,7:F4},{1,7:F4},{2,7:F4},{3,7:F4}", m.M31, m.M32, m.M33, m.M34) );
			txtHelper.DrawTextLine( String.Format("m:{0,7:F4},{1,7:F4},{2,7:F4},{3,7:F4}", m.M41, m.M42, m.M43, m.M44) );

			txtHelper.DrawTextLine("WorldMatrix * ViewMatrix");
			m = camera.WorldMatrix * camera.ViewMatrix;
			txtHelper.DrawTextLine( String.Format("m:{0,7:F4},{1,7:F4},{2,7:F4},{3,7:F4}", m.M11, m.M12, m.M13, m.M14) );
			txtHelper.DrawTextLine( String.Format("m:{0,7:F4},{1,7:F4},{2,7:F4},{3,7:F4}", m.M21, m.M22, m.M23, m.M24) );
			txtHelper.DrawTextLine( String.Format("m:{0,7:F4},{1,7:F4},{2,7:F4},{3,7:F4}", m.M31, m.M32, m.M33, m.M34) );
			txtHelper.DrawTextLine( String.Format("m:{0,7:F4},{1,7:F4},{2,7:F4},{3,7:F4}", m.M41, m.M42, m.M43, m.M44) );
*/


/*
			txtHelper.DrawTextLine( "windowWidth ;" +windowWidth.ToString() );
			txtHelper.DrawTextLine( "windowHeight:" +windowHeight.ToString() );
*/

//			txtHelper.DrawTextLine( "pick     :"+pickedEdgeX.ToString()+pickedEdgeY.ToString()+pickedEdgeZ.ToString() );

			txtHelper.DrawTextLine( "mouseOver:" + mouseOverX.ToString() + " / " + mouseOverY.ToString() + " / " + mouseOverZ.ToString()  );

			txtHelper.DrawTextLine( "Turn:"+this.board.getTurns().ToString()+" / "+ this.board.iMAX_TURNS );

//			txtHelper.DrawTextLine( "CurrentColor:"+this.board.getCurrentColor().ToString() );

			ArrayList posAL = this.board.getMovablePos();
			
			if( Disc. == this.board.getCurrentColor() )
			{
				txtHelper.SetForegroundColor(System.Drawing.Color.DarkOrange );
				txtHelper.DrawTextLine(">̔ łĂꏊ̐:"+posAL.Count.ToString());
			}
			else
			{
				txtHelper.SetForegroundColor(System.Drawing.Color.White);
				txtHelper.DrawTextLine(">̔ łĂꏊ̐:"+posAL.Count.ToString());
			}


			txtHelper.SetForegroundColor(System.Drawing.Color.White);

			txtHelper.DrawTextLine(	":"+this.board.countDisc(Disc.).ToString() +
				" :"+this.board.countDisc(Disc.).ToString() +
				" :"+this.board.countDisc(Disc.).ToString() );


#if(DEBUG)
			txtHelper.DrawTextLine( String.Format("col(debug):{0,7:X8}", this.icol ) );

			// ÕG[bZ[W
			txtHelper.DrawTextLine(	"s(debug):" + this.debugJE^.ToString() );
			if( null != this.ErrMsg )
			{
				txtHelper.SetForegroundColor(System.Drawing.Color.Red);
				txtHelper.DrawTextLine(	"ErrMsg:" + this.ErrMsg );
			}
#endif


			// Draw help
			if ( isHelpShowing )
			{
				txtHelper.SetInsertionPoint(10, sampleFramework.BackBufferSurfaceDescription.Height-15*6);
				txtHelper.SetForegroundColor(System.Drawing.Color.DarkOrange);
				txtHelper.DrawTextLine("Cg]: }EX ~h {^ hbO");
				txtHelper.DrawTextLine("Q[: i L[");
				txtHelper.DrawTextLine("zoom: PageUp/PageDown L[");
				txtHelper.DrawTextLine("Quit: Esc");
				txtHelper.DrawTextLine("Hide help: F1");
			}
			else
			{
				txtHelper.SetInsertionPoint(10, sampleFramework.BackBufferSurfaceDescription.Height-15*2);
				txtHelper.SetForegroundColor(System.Drawing.Color.White);
				txtHelper.DrawTextLine("Press F1 for help");
			}



			// --------------------------------
			// Q[I/pX
			// bZ[W EBhEɕ\
			// 1.Q[I
			if( this.board.isGameOver() )
			{
				if( this.board.countDisc(Disc.) == this.board.countDisc(Disc.) )
				{
					firstFont.DrawText(
						null,				// XvCg
						"--- Q[I ---\n  ",	// text (\n:s)
						new System.Drawing.Rectangle( windowWidth/2-100, windowHeight-80, 0, 0),	// \ʒu 
						DrawTextFormat.NoClip,
						System.Drawing.Color.DarkOrange);	// F
				}
				else if( this.board.countDisc(Disc.) > this.board.countDisc(Disc.) )
				{
					firstFont.DrawText(
						null,				// XvCg
						"--- Q[I ---",	// text (\n:s)
						new System.Drawing.Rectangle( windowWidth/2-100, windowHeight-80, 0, 0),	// \ʒu 
						DrawTextFormat.NoClip,
						System.Drawing.Color.DarkOrange );	// F
					firstFont.DrawText(
						null,				// XvCg
						" ̏ ",	// text (\n:s)
						new System.Drawing.Rectangle( windowWidth/2-100, windowHeight-60, 0, 0),	// \ʒu 
						DrawTextFormat.NoClip,
						System.Drawing.Color.DarkGray);	// F
				}
				else
				{
					firstFont.DrawText(
						null,				// XvCg
						"--- Q[I ---",	// text (\n:s)
						new System.Drawing.Rectangle( windowWidth/2-100, windowHeight-80, 0, 0),	// \ʒu 
						DrawTextFormat.NoClip,
						System.Drawing.Color.DarkOrange );	// F
					firstFont.DrawText(
						null,				// XvCg
						" ̏ ",	// text (\n:s)
						new System.Drawing.Rectangle( windowWidth/2-100, windowHeight-60, 0, 0),	// \ʒu 
						DrawTextFormat.NoClip,
						System.Drawing.Color.White );	// F
				}

				//  (΂̐) \
				string st = ":"+this.board.countDisc(Disc.).ToString() + " / :"+this.board.countDisc(Disc.).ToString();
				firstFont.DrawText(
					null,				// XvCg
					st,					// text (\n:s)
					new System.Drawing.Rectangle( windowWidth/2-100, windowHeight-40, 0, 0),	// \ʒu 
					DrawTextFormat.NoClip,
					System.Drawing.Color.DarkOrange );	// F

				// ------------------------------------------------------------
				// ---debug---
				// debugp Ďs (ȉ2sLɂƃQ[JԂ)
//				this.board.init();	// Q[̏
//				debugJE^++;

			}
				// 2.pX(Q[IłȂAłĂꏊȂꍇ)
			else if( 0 == posAL.Count )
			{
				if( Disc. == this.board.getCurrentColor() )
				{
					firstFont.DrawText(
						null,				// XvCg
						"=== pXI NbNĂB ===",	// text (\n:s)
						new System.Drawing.Rectangle( windowWidth/2-100, windowHeight-60, 0, 0),	// \ʒu 
						DrawTextFormat.NoClip,
						System.Drawing.Color.Yellow );	// F
					firstFont.DrawText(
						null,				// XvCg
						" :pXI ",	// text (\n:s)
						new System.Drawing.Rectangle( windowWidth/2-100, windowHeight-40, 0, 0),	// \ʒu 
						DrawTextFormat.NoClip,
						System.Drawing.Color.DarkGray );	// F
				}
				else
				{
					firstFont.DrawText(
						null,				// XvCg
						"=== pXI NbNĂB ===",	// text (\n:s)
						new System.Drawing.Rectangle( windowWidth/2-100, windowHeight-60, 0, 0),	// \ʒu 
						DrawTextFormat.NoClip,
						System.Drawing.Color.Yellow );	// F
					firstFont.DrawText(
						null,				// XvCg
						" :pXI ",	// text (\n:s)
						new System.Drawing.Rectangle( windowWidth/2-100, windowHeight-40, 0, 0),	// \ʒu 
						DrawTextFormat.NoClip,
						System.Drawing.Color.White);	// F
				}
			}
			// --------------------------------


			txtHelper.End();
		}





		/// <summary>
		/// As a convenience, the sample framework inspects the incoming windows messages for
		/// keystroke messages and decodes the message parameters to pass relevant keyboard
		/// messages to the application.  The framework does not remove the underlying keystroke 
		/// messages, which are still passed to the application's MsgProc callback.
		/// </summary>
		private void OnKeyEvent(object sender, System.Windows.Forms.KeyEventArgs e)
		{

			switch(e.KeyCode)
			{
				case System.Windows.Forms.Keys.F1:
					isHelpShowing = !isHelpShowing;
					break;

				case System.Windows.Forms.Keys.I:
					ErrMsg = null;		// OG[bZ[W NA
					this.board.init();	// Q[̏
					break;

				case System.Windows.Forms.Keys.U:
					// HumanPlayerNX OnTurn\bhundoʒm
					this.pickedEdgeX = -2;
					this.pickedEdgeY = -2;
					this.pickedEdgeZ = -2;
					break;

				// L[͂ɂύXJƕ`撆SԂ̋
				case System.Windows.Forms.Keys.PageUp:
					this.Jlen = this.Jlen + 0.5f;
					camera.SetRadius( this.Jlen, 1.0f, 512.0f );	// J̋ default,min,max
					break;

				case System.Windows.Forms.Keys.PageDown:
					this.Jlen = this.Jlen - 0.5f;
					camera.SetRadius( this.Jlen, 1.0f, 512.0f );	// J̋ default,min,max
					break;

//				case System.Windows.Forms.Keys.Escape:

			}
		}

		/// <summary>
		/// Before handling window messages, the sample framework passes incoming windows 
		/// messages to the application through this callback function. If the application sets 
		/// noFurtherProcessing to true, the sample framework will not process the message
		/// </summary>
		public IntPtr OnMsgProc(IntPtr hWnd, NativeMethods.WindowMessage msg, IntPtr wParam, IntPtr lParam, ref bool noFurtherProcessing)
		{
			// Give the dialog a chance to handle the message first
			noFurtherProcessing = hud.MessageProc( hWnd, msg, wParam, lParam );
			if (noFurtherProcessing)
				return IntPtr.Zero;

			noFurtherProcessing = sampleUi.MessageProc( hWnd, msg, wParam, lParam );
			if (noFurtherProcessing)
				return IntPtr.Zero;

			noFurtherProcessing = AIvsAIUi.MessageProc( hWnd, msg, wParam, lParam );
			if (noFurtherProcessing)
				return IntPtr.Zero;

			// Give the light control a chance now
			CgRg[.HandleMessages( hWnd, msg, wParam, lParam );

			// Pass all remaining windows messages to camera so it can respond to user input
			camera.HandleMessages( hWnd, msg, wParam, lParam );

			// }EX J[\ʒu 擾
			mouseX = NativeMethods.LoWord( (uint)lParam.ToInt32() );
			mouseY = NativeMethods.HiWord( (uint)lParam.ToInt32() );

			return IntPtr.Zero;
		}






		/// <summary>
		/// Initializes the application
		/// </summary>
		public void InitializeApplication()
		{
			// -----------------------------------------------
			// Q[ݒ̓Ǎ"ExGrid2.config"
			try 
			{
				//ۑ̃t@C (exẽtpX擾ÃfBNg𓾂)
				string	fileName =	System.IO.Path.GetDirectoryName( System.Windows.Forms.Application.ExecutablePath )
									+ "\\" + "ExGrid2.config";


				//XMLt@Cǂݍށ
				//XmlSerializerIuWFNg̍쐬
				System.Xml.Serialization.XmlSerializer	serializer2 =
					new System.Xml.Serialization.XmlSerializer(typeof(ConfigDat));

				//t@CJ
				System.IO.FileStream	fs2 = new System.IO.FileStream( fileName, System.IO.FileMode.Open );

				//XMLt@Cǂݍ݁AtVA
				this.ConfigDat	= (ConfigDat)serializer2.Deserialize(fs2);

				//
				fs2.Close();
			}
			catch
			{
				// OAǂݍ܂Ȃ
			} 
			// -----------------------------------------------
		

			int y = 10;

			// Initialize the HUD
			Button fullScreen	= hud.AddButton( ToggleFullscreen, "Toggle full screen",    35, y,       125,22 );
			Button toggleRef	= hud.AddButton( ToggleReference,  "Toggle reference (F3)", 35, y += 24, 125,22 );
			Button changeDevice	= hud.AddButton( ChangeDevice,     "Change Device (F2)",    35, y += 24, 125,22 );

			// Hook the button events for when these items are clicked
			fullScreen.Click	+= new EventHandler( OnFullscreenClicked );
			toggleRef.Click		+= new EventHandler( OnRefClicked );
			changeDevice.Click	+= new EventHandler( OnChangeDevicClicked );

			// Now add the sample specific UI
			y = 0;

			const int Button1		= ChangeDevice + 10;
			sampleUi.AddButton( Button1, "Undo", 35, y+=24, 125, 22 );
			sampleUi.GetButton( Button1 ).Click += new EventHandler( OnUndo );

			const int Button2		= ChangeDevice + 20;
			sampleUi.AddButton( Button2, "ݒ", 35, y+=24, 125, 22 );
			sampleUi.GetButton( Button2 ).Click += new EventHandler( Onݒ );


			// "W\"`FbN{bNX
			const int CheckBox4		= ChangeDevice + 40;
//			sampleUi.AddCheckBox( CheckBox4, "W\", 35, y+=24, 125, 22, false );
			sampleUi.AddCheckBox( CheckBox4, "W\", 35, y+=24, 125, 22, this.ConfigDat.bW\ );
			sampleUi.GetCheckbox( CheckBox4 ).Changed += new EventHandler( OnW\ );

			this.bW\ = this.ConfigDat.bW\;

			// wiFύXXC_[
			const int SliderControl = ChangeDevice + 50;
			//                              id             x   y      w    h   min max  l
//			Slider sl = sampleUi.AddSlider( SliderControl, 30, y+=24, 100, 22, 1,  41,  16, false );
			Slider sl = sampleUi.AddSlider( SliderControl, 30, y+=24, 100, 22, 1,  41,  this.ConfigDat.wiFW, false );

			// XC_[ Cxgnh
			sl.ValueChanged += new EventHandler( OnwiF`FW );

			this.icolW = this.ConfigDat.wiFW;
			icol = icol * this.ConfigDat.wiFW;

			this.Config = new Config( ref this.ConfigDat );

			CgRg[ = new DirectionWidget();
			CgRg[.LightDirection = new Vector3( 0.4285f, 0.7673f, -0.3430f );	// Cg̐ݒ
		}

		
		
		
		/// <summary>
		/// wiF`FW
		/// </summary>
		private void OnwiF`FW(object sender, EventArgs e)
		{
			// XC_[̒l擾
			this.icolW = (sender as Slider).Value;
			icol = icol * icolW;

			this.ConfigDat.wiFW = icolW;

		}


		/// <summary>
		/// AIvsAI Q[is
		/// </summary>
		private void OnQ[is(object sender, EventArgs e)
		{
			bQ[is	= !bQ[is;
		}


		/// <summary>
		/// W\
		/// </summary>
		private void OnW\(object sender, EventArgs e)
		{
			bW\	= !bW\;
			this.ConfigDat.bW\ = bW\;
		}



		/// <summary>
		/// Undos
		/// </summary>
		private void OnUndo( object sender, EventArgs e )
		{
			// HumanPlayerNX OnTurn\bhundoʒm
			this.pickedEdgeX = -2;
			this.pickedEdgeY = -2;
			this.pickedEdgeZ = -2;
		}


		/// <summary>
		/// Q[ݒ_CAOJ
		/// </summary>
		private void Onݒ( object sender, EventArgs e )
		{
			applicationState = ApplicationState.Config;
		}





		/// <summary>
		/// Q[ݒ_CAOOKꂽꍇ
		/// </summary>
		private void GAMEݒ( Device device )
		{
			ErrMsg = null;	// OG[bZ[W NA

			// ---------------------------------------------------
			// Q[ݒ_CAOOKꂽꍇ
			if( this.board != null )
			{
				this.board.Dispose();
			}

			this.current_player = 0;	// ݂̃vC[

			int board_size	=  8;
			int rule		= 26;

			if     ( ConfigDat.{[hTCY == "4x4x4" ){ board_size = 4; }
			else if( ConfigDat.{[hTCY == "6x6x6" ){ board_size = 6; }
			else if( ConfigDat.{[hTCY == "8x8x8" ){ board_size = 8; }

			if     ( ConfigDat.͂߂ == "΂ߖ( 6)" ){ rule =  6; }
			else if( ConfigDat.͂߂ == "΂ߗL(26)" ){ rule = 26; }

			this.board = new Board( board_size, rule );	// {[hTCY,ԂƂo
			this.board.CreateVB( device );

			AIvsAIUi.RemoveAllControls();	// "AI vs AI is"`FbN{bNX (AIvsAȈꍇ̂ݕ\)

			// vC[ݒ
			if( ConfigDat.vC[^Cv == "l vs l" )
			{
				player[0] = new HumanPlayer();	// 1 (Undos̉)
				player[1] = new HumanPlayer();	// 1
			}
			else if( ConfigDat.vC[^Cv == "l vs AI" )
			{
				player[0] = new HumanPlayer();	// 2 
				player[1] = new AIPlayer();		// 1

				player[1].level = ConfigDat.iAIx;
			}
			else if( ConfigDat.vC[^Cv == "AI vs l" )
			{
				player[0] = new AIPlayer();		// 1
				player[1] = new HumanPlayer();	// 2

				player[0].level = ConfigDat.iAIx;
			}
			else if( ConfigDat.vC[^Cv == "AI vs AI" )
			{
				player[0] = new AIPlayer();		// 1 
				player[1] = new AIPlayer();		// 1
							
				player[0].level = ConfigDat.iAIx;	//  
				player[1].level = ConfigDat.iAIx;	// 

				// "AI vs AI is"`FbN{bNX (AIvsAȈꍇ̂ݕ\)
				const int CheckBox3		= ChangeDevice + 30;

//				AIvsAIUi.AddCheckBox( CheckBox3, "AI vs AI is", 35,  0, 125,22, false );
				AIvsAIUi.AddCheckBox( CheckBox3, "AI vs AI is", 35, 24, 125,22, false );// 1s:+24
				AIvsAIUi.GetCheckbox( CheckBox3 ).Changed += new EventHandler( OnQ[is );
				bQ[is	= false;
			}
			// ---------------------------------------------------


		}






		/// <summary>
		/// Q[ݒ_CAO.ConfigDatɐݒ
		/// </summary>
		/// <returns></returns>
		public int XMLConfigݒ()
		{

			XmlAttributeCollection	attrColl;
			XmlAttribute			attr;

			try 
			{
				string	st;

				// ========================================================================
				//<setup {[hTCY="8" ͂߂="26" vC[^Cv="l vs AI" AIx="3" AIx="3" AIx="3" />
				m_Node = m_doc.SelectSingleNode( "//setup" );	// XPath ƈvŏ XmlNode I

				// w̑̒l擾
				attrColl	= m_Node.Attributes;

				attr = (XmlAttribute)attrColl.GetNamedItem( "{[hTCY"	);
				st = attr.Value;
				if     ( "4" == st ){ ConfigDat.{[hTCY = "4x4x4"; }
				else if( "6" == st ){ ConfigDat.{[hTCY = "6x6x6"; }
				else                { ConfigDat.{[hTCY = "8x8x8"; }


				attr = (XmlAttribute)attrColl.GetNamedItem( "͂߂"	);
				st = attr.Value;
				if     ( "6" == st ){ ConfigDat.͂߂ = "΂ߖ( 6)"; }
				else                { ConfigDat.͂߂ = "΂ߗL(26)"; }


				attr = (XmlAttribute)attrColl.GetNamedItem( "vC[^Cv" );
				st = attr.Value;
				if     ( "l vs l" == st ){ ConfigDat.vC[^Cv = st; }
				else if( "l vs AI" == st ){ ConfigDat.vC[^Cv = st; }
				else if( "AI vs l" == st ){ ConfigDat.vC[^Cv = st; }
				else if( "AI vs AI" == st ){ ConfigDat.vC[^Cv = st; }
				else                       { ConfigDat.vC[^Cv = st; } // ǂłȂꍇ

				attr = (XmlAttribute)attrColl.GetNamedItem( "AIx" );
				st = attr.Value;
				ConfigDat.iAIx = System.Convert.ToInt32(st);

				attr = (XmlAttribute)attrColl.GetNamedItem( "AIx" );
				st = attr.Value;
				ConfigDat.iAIx = System.Convert.ToInt32(st);

				attr = (XmlAttribute)attrColl.GetNamedItem( "AIx" );
				st = attr.Value;
				ConfigDat.iAIx = System.Convert.ToInt32(st);

				// int^ɕϊ OKv
//				i = System.Convert.ToInt32(st);
			}
			catch (Exception exc)
			{
				// ÕG[
				this.ErrMsg = exc.Message + exc.GetType().ToString();

				return -1;
			} 

			return 0;
		}




		// ----------------------------------------
		// XML菇t@CLoad
		public void XMLLoad( Device device )
		{
			// 1.xmlt@Cǂݍ(_CAOŎw肳ꂽxmlt@Cm_docɃ[h)
			// 2.Q[ݒ_CAO.ConfigDatɐݒ
			// 3.GAMEݒ胁\bhs
			// ɂxml̓e_CAOɔf

			m_doc  = new XmlDocument();

			XmlLoad	XmlLoad = new XmlLoad();	// XmlLoad_CAONX
			bool	Result;						// _CAO ok ̏ꍇ true

			applicationState = ApplicationState.RenderScene;

			// XMLt@CI[v_CAO
			Result = XmlLoad.XmlOpenFile( m_doc );

			if( true == Result )
			{
				this.XMLConfigݒ();	// Q[ݒ_CAO.ConfigDatxml̓eݒ

				this.GAMEݒ( device );

				// xmlɋLqꂽ^[s

				// ========================================================================
				//  <GAME turn="0" Player="1" x="4" y="4" z="3" />
				//  <GAME turn="1" Player="-1" x="6" y="5" z="5" />

				XmlAttributeCollection	attrColl;
				XmlAttribute			attr;

				string		st;
				ArrayList	AIposAL;

				try 
				{
					m_nodeList = m_doc.SelectNodes( "//GAME" ); // SelectNodes:XPath ƈvm[hXgI

					// foreach in [v: m[hXg ̃m[hɂđSď 
					foreach ( XmlNode nd in m_nodeList )
					{
						// w̑̒l擾
						attrColl	= nd.Attributes;

						attr = (XmlAttribute)attrColl.GetNamedItem("turn");
						attr = (XmlAttribute)attrColl.GetNamedItem("Player");
						attr = (XmlAttribute)attrColl.GetNamedItem("x");
						attr = (XmlAttribute)attrColl.GetNamedItem("y");
						attr = (XmlAttribute)attrColl.GetNamedItem("z");

						// !! `FbNǉ turnł邱

						int x,y,z;

						attr = (XmlAttribute)attrColl.GetNamedItem("x");
						st = attr.Value;
						x = System.Convert.ToInt32(st);

						attr = (XmlAttribute)attrColl.GetNamedItem("y");
						st = attr.Value;
						y = System.Convert.ToInt32(st);

						attr = (XmlAttribute)attrColl.GetNamedItem("z");
						st = attr.Value;
						z = System.Convert.ToInt32(st);

						board.move( new Point( x,y,z ) );	// vC[

						AIposAL = board.getMovablePos();

						// LOAD̒
						// 1łāǍʑłĂ肪ꍇ:pX
						// vC[ēxサA2xđłB
						if( 0 == AIposAL.Count )			// łĂ鏊Ȃꍇ:pX
						{
							board.pass();	// vC[
						}
					}
				}
				catch (Exception exc) 
				{
					this.ErrMsg = exc.Message + exc.GetType().ToString();
				} 
			}
		}



		// ----------------------------------------
		// XML菇t@CSave(ݒ_CAOĂ΂)
		public void XmlDSave( string filename )
		{
			// XMLo
			this.board.XmlSave(
				filename,
				this.player[0].getType(),		// vC[^Cv l/AI
				this.player[1].getType(),
				this.ConfigDat.iAIx,		// lvsAI AIx
				this.ConfigDat.iAIx,		// AIvsAI AIx
				this.ConfigDat.iAIx );	// AIvsAI AIx
		}



        /// <summary>Called when the change device button is clicked</summary>
        private void OnChangeDevicClicked(object sender, EventArgs e)
        {
            sampleFramework.ShowSettingsDialog(!sampleFramework.IsD3DSettingsDialogShowing);
        }

        /// <summary>Called when the full screen button is clicked</summary>
        private void OnFullscreenClicked(object sender, EventArgs e)
        {
            sampleFramework.ToggleFullscreen();
        }

        /// <summary>Called when the ref button is clicked</summary>
        private void OnRefClicked(object sender, EventArgs e)
        {
            sampleFramework.ToggleReference();
        }





        /// <summary>
        /// Entry point to the program. Initializes everything and goes into a message processing 
        /// loop. Idle time is used to render the scene.
        /// </summary>
        static int Main() 
        {
            System.Windows.Forms.Application.EnableVisualStyles();
            using(Framework sampleFramework = new Framework())
            {
                ExGrid2 sample = new ExGrid2(sampleFramework);
                // Set the callback functions. These functions allow the sample framework to notify
                // the application about device changes, user input, and windows messages.  The 
                // callbacks are optional so you need only set callbacks for events you're interested 
                // in. However, if you don't handle the device reset/lost callbacks then the sample 
                // framework won't be able to reset your device since the application must first 
                // release all device resources before resetting.  Likewise, if you don't handle the 
                // device created/destroyed callbacks then the sample framework won't be able to 
                // recreate your device resources.
                sampleFramework.Disposing		+= new EventHandler(sample.OnDestroyDevice);
                sampleFramework.DeviceLost		+= new EventHandler(sample.OnLostDevice);
                sampleFramework.DeviceCreated	+= new DeviceEventHandler(sample.OnCreateDevice);
                sampleFramework.DeviceReset		+= new DeviceEventHandler(sample.OnResetDevice);

                sampleFramework.SetWndProcCallback(new WndProcCallback(sample.OnMsgProc));

                sampleFramework.SetCallbackInterface(sample);
                try
                {

                    // Show the cursor and clip it when in full screen
                    sampleFramework.SetCursorSettings(true, true);

                    // Initialize
                    sample.InitializeApplication();

                    // Initialize the sample framework and create the desired window and Direct3D 
                    // device for the application. Calling each of these functions is optional, but they
                    // allow you to set several options which control the behavior of the sampleFramework.
                    sampleFramework.Initialize( true, true, true ); // Parse the command line, handle the default hotkeys, and show msgboxes
                    sampleFramework.CreateWindow("ExGrid2");
                    // Hook the keyboard event
                    sampleFramework.Window.KeyDown += new System.Windows.Forms.KeyEventHandler(sample.OnKeyEvent);
                    sampleFramework.CreateDevice( 0, true, Framework.DefaultSizeWidth, Framework.DefaultSizeHeight, 
                        sample);

                    // Pass control to the sample framework for handling the message pump and 
                    // dispatching render calls. The sample framework will call your FrameMove 
                    // and FrameRender callback when there is idle time between handling window messages.
                    sampleFramework.MainLoop();

                }
#if(DEBUG)
                catch (Exception e)
                {
                    // In debug mode show this error (maybe - depending on settings)
                    sampleFramework.DisplayErrorMessage(e);
#else
            catch
            {
                // In release mode fail silently
#endif
                    // Ignore any exceptions here, they would have been handled by other areas
                    return (sampleFramework.ExitCode == 0) ? 1 : sampleFramework.ExitCode; // Return an error code here
                }

                // Perform any application-level cleanup here. Direct3D device resources are released within the
                // appropriate callback functions and therefore don't require any cleanup code here.

				
				return sampleFramework.ExitCode;
            }
        }





		
		



























		// --------------------------------------------------------------------------
		// --------------------------------------------------------------------------
		/// <summary>
		/// ΂łĂObĥ݂ΏۂƂsbNo
		/// </summary>
		private void MovablesbNo()
		{
			// -3,-3,-3 }EXNbN\
			this.pickedEdgeX = -3;
			this.pickedEdgeY = -3;
			this.pickedEdgeZ = -3;

			float	minDist = float.MaxValue;	// XN[sbNΏۂ܂ł̋(߂̂ΏۂƂB)

			// r[|[g
			Viewport	viewport	= new Viewport();

			viewport.Width	= this.windowWidth;
			viewport.Height = this.windowHeight;

			viewport.X		= viewport.Y = 0;

			viewport.MaxZ	= 1.0f;
			viewport.MinZ	= 0.0f;

			ArrayList posAL = this.board.getMovablePos();

			for( int i = 0; i < posAL.Count; i++ )
			{
				Point p = (Point)posAL[i];

				// NbNXN[W烌CvZAObhƂ̌`FbN 
				Vector3	vNear = Vector3.Unproject(
					new Vector3( mouseX, mouseY, viewport.MinZ ), // r[|[gԓł̃NbNꂽ_̋ߕʏ̈ʒu
					viewport,
					projMat,
					viewMat,
					this.board.GridMat[p.x, p.y, p.z] * worldMat );	//s

				Vector3 vFar = Vector3.Unproject(
					new Vector3( mouseX, mouseY, viewport.MaxZ ),	// r[|[gԓł̃NbNꂽ_̉ʏ̈ʒu
					viewport,
					projMat,
					viewMat,
					this.board.GridMat[p.x, p.y, p.z] * worldMat );	//s

				Vector3 vDir = Vector3.Normalize( vFar - vNear );

				IntersectInformation	closestHit = new IntersectInformation();

				if( this.board.mesh.Intersect( vNear, vDir, out closestHit ) )
				{
					if( minDist > closestHit.Dist )
					{
						pickedEdgeX = p.x;
						pickedEdgeY = p.y;
						pickedEdgeZ = p.z;

						minDist = closestHit.Dist;	// XN[sbNΏۂ܂ł̋(߂̂ΏۂƂB)
					}
				}
			}
		}
		// --------------------------------------------------------------------------
		// --------------------------------------------------------------------------



		// --------------------------------------------------------------------------
		// --------------------------------------------------------------------------
		/// <summary>
		/// ΂łĂObĥ݂ΏۂƂ}EXI[oo
		/// </summary>
		private void Movable}EXI[oo()
		{
			// mouseOverX,Y,ZɃ}EXI[oObhWݒ
			// -1,-1,-1 }EX̉ɐ΂łĂObhƂ\
			this.mouseOverX = -1;
			this.mouseOverY = -1;
			this.mouseOverZ = -1;

			float	minDist = 10000.0f;;	// XN[sbNΏۂ܂ł̋(߂̂ΏۂƂB)

			// r[|[g
			Viewport	viewport	= new Viewport();

			viewport.Width	= this.windowWidth;
			viewport.Height = this.windowHeight;

			viewport.X = viewport.Y = 0;

			viewport.MaxZ	= 1.0f;
			viewport.MinZ	= 0.0f;

			ArrayList posAL = this.board.getMovablePos();	// ΂łĂWArrayList

			for( int i = 0; i < posAL.Count; i++ )
			{
				Point p = (Point)posAL[i];

				// NbNXN[W烌CvZAObhƂ̌`FbN 
				Vector3	vNear = Vector3.Unproject(
					new Vector3( mouseX, mouseY, viewport.MinZ ), // r[|[gԓł̃NbNꂽ_̋ߕʏ̈ʒu
					viewport,
					projMat,
					viewMat,
					this.board.GridMat[p.x, p.y, p.z] * worldMat );	//s

				Vector3 vFar = Vector3.Unproject(
					new Vector3( mouseX, mouseY, viewport.MaxZ ),	// r[|[gԓł̃NbNꂽ_̉ʏ̈ʒu
					viewport,
					projMat,
					viewMat,
					this.board.GridMat[p.x, p.y, p.z] * worldMat );	//s

				Vector3 vDir = Vector3.Normalize( vFar - vNear );

				IntersectInformation	closestHit = new IntersectInformation();	// CƎOp`̌Lq

				if( this.board.mesh.Intersect( vNear, vDir, out closestHit ) )		// CbVɓ邩ǂ𔻕
				{
					if( minDist > closestHit.Dist )
					{
						mouseOverX = p.x;
						mouseOverY = p.y;
						mouseOverZ = p.z;

						minDist = closestHit.Dist;	// XN[sbNΏۂ܂ł̋(߂̂ΏۂƂB)
					}
				}
			} // for end
		}
		// --------------------------------------------------------------------------
		// --------------------------------------------------------------------------










    }
}
