using System;
using System.Collections;

using Microsoft.DirectX;
using Microsoft.DirectX.Direct3D;
using Microsoft.Samples.DirectX.UtilityToolkit;

using System.Drawing;
using Direct3D=Microsoft.DirectX.Direct3D;

// j[.vWFNg.QƂ̒ǉsystem.xml.dllǉ
using System.Xml;


namespace ExGrid2Sample
{
	/// <summary>
	/// 
	/// </summary>
	public class Board : ICloneable
	{
		// \ v\ (:ỉE = i0130)
		public const int iNONE		= 0x00000000;
		public const int i		= 0x00000001;
		public const int i0000	= 0x00000002;
		public const int i0130	= 0x00000004;
		public const int i0300	= 0x00000008;
		public const int i0430	= 0x00000010;
		public const int i0600	= 0x00000020;
		public const int i0730	= 0x00000040;
		public const int i0900	= 0x00000080;
		public const int i1030	= 0x00000100;
		public const int i0000	= 0x00000200;
		public const int i0130	= 0x00000400;
		public const int i0300	= 0x00000800;
		public const int i0430	= 0x00001000;
		public const int i0600	= 0x00002000;
		public const int i0730	= 0x00004000;
		public const int i0900	= 0x00008000;
		public const int i1030	= 0x00010000;
		public const int i		= 0x00020000;
		public const int i0000	= 0x00040000;
		public const int i0130	= 0x00080000;
		public const int i0300	= 0x00100000;
		public const int i0430	= 0x00200000;
		public const int i0600	= 0x00400000;
		public const int i0730	= 0x00800000;
		public const int i0900	= 0x01000000;
		public const int i1030	= 0x02000000;

		// [ݒ
		private	int BoardSize;	// {[hTCY(ӂ̒) 4/6/8

		private	int Rule;		// ΂uɗԂƂow
								// 6:6 / 6ȊO:26(΂ߕ܂)

		private	int MaxTurns;

		private	float	corner;	// ϊɊpɂȂW̒l

        private	Vector3[]	p	= new Vector3[8];	// p̍Wl

		private	ArrayList	MkMouseOver = new ArrayList();	// }EXI[oł̏ꏊɑłꍇɕς΂i[
		private	Point		Last}EXI[o|Cg = new Point( -1, -1, -1 );	// Õ}EXI[oW


// Clone Ώ------------------------------------------------
		// {[hTCY+ǂ̔z F(///)i[
		private	int[,,]			RawBoard;
		private	int[,,]			Jx;

		private	int[,,]			W;	// W p=2 / pɗא=1/ȊO=0 ŕ\Fς


		private	int				Turns;			// 萔(0n܂)
		private	int				CurrentColor;	// ݂̃vC[

		private	ArrayList		UpdateLog = new ArrayList();
		/*
		uł΁vƁuԂ΁vi[ArrayListi[
			ArrayList	ł+Ԃ...
			ArrayList	ł+Ԃ...
					.
					.		
			pass̏ꍇ:	new ArrayList i[
		*/

		// łĂʒu̍Wi[Vector
		private	ArrayList[]		MovablePos;

		// łĂ_L^ĂVector[ 萔, x, y, z ]
		private	int[,,,]		MovableDir;

		// eF̐΂̐
		private	ColorStorage	Discs	= new ColorStorage();



		// ====================================================================
		// DirectX ֘A
		private	Matrix[,,]		m_GridMat;				// \/sbNp}gbNX

		private	VertexBuffer	vertexBuffer	= null;
		private VertexBuffer	m_SquareBuffer	= null;	// g(lp)
		private VertexBuffer	m_LineBuffer	= null;	// }EXI[o }[Np

		private	Mesh			m_mesh			= null;	// Our mesh object in sysmem

		private	Mesh			m_meshMk		= null;	// }EXI[oŕςΕ\p
		private	Mesh			m_meshLastMk	= null;	// Ōɑłʒu\p

		private	Mesh			m_meshMouseOver	= null;	// }EXI[oObh\p

		private	Mesh			m_mesh		= null;	// 󂫍W\

		public	int				iGrid;					// Obh̑

		// ANZT ----------------------------------------------------------------------
		public Matrix[,,]	GridMat 
		{
			get{ return	m_GridMat; }
		}

		public int	iBOARD_SIZE
		{
			get{ return	BoardSize; }
		}

		public int	iRULE
		{
			get{ return	Rule; }
		}

		public int	iMAX_TURNS
		{
			get{ return	MaxTurns; }
		}

		public Mesh	mesh
		{
			get{ return	m_mesh; }
		}

		public Board( int board_size, int rule )
		{
			// 
			// TODO: RXgN^ WbNɒǉĂB
			//

			BoardSize	= board_size;	// {[hTCY(ӂ̒) 4/6/8

			Rule		= rule;			// ΂uɗԂƂow
										// 6:6 / 6ȊO:26(΂ߕ܂)

			corner = this.iBOARD_SIZE / 2 - 0.5f;	// ϊɊpɂȂW̒l

			p[0] = new Vector3(-corner,-corner,-corner );
			p[1] = new Vector3( corner,-corner,-corner );
			p[2] = new Vector3( corner, corner,-corner );
			p[3] = new Vector3(-corner, corner,-corner );

			p[4] = new Vector3(-corner,-corner, corner );
			p[5] = new Vector3( corner,-corner, corner );
			p[6] = new Vector3( corner, corner, corner );
			p[7] = new Vector3(-corner, corner, corner );


			MaxTurns	=  BoardSize * BoardSize * BoardSize - 8;

			// {[hTCY+ǂ̔z F(///)i[
			RawBoard	= new int   [ BoardSize+2, BoardSize+2, BoardSize+2 ];

			Jx		= new int   [ BoardSize+2, BoardSize+2, BoardSize+2 ];

			W	= new int   [ BoardSize+2, BoardSize+2, BoardSize+2 ];

			// sbNp}gbNX
			m_GridMat	= new Matrix[ BoardSize+2, BoardSize+2, BoardSize+2 ];

			// łĂʒu̍Wi[Vector
			MovablePos	= new ArrayList[ MaxTurns+1 ];

			// łĂ_L^ĂVector[ 萔, x, y, z ]
			MovableDir	= new int[ MaxTurns+1, BoardSize+2, BoardSize+2, BoardSize+2 ];

			iGrid		= BoardSize * BoardSize * BoardSize;	// Obh̑


			// Vector̔z
			for( int i=0; i <= MaxTurns; i++ )
			{
				MovablePos[i] = new ArrayList();
			}

            this.initW();	// Wʐݒ p=2/pɗא=1/ȊO=0

			init();

		}


		/// <summary>
		/// BoardNXfB[vRs[
		/// </summary>
		public object Clone()
		{
			return new Board( this );
		}

		/// <summary>
		/// BoardNX fB[vRs[pRXgN^(AIvC[vlpɃRs[)
		/// sc:Rs[
		/// </summary>
		public Board( Board	sc )
		{
			this.BoardSize	= sc.BoardSize;
			this.Rule		= sc.Rule;

			RawBoard	= new int   [ BoardSize+2, BoardSize+2, BoardSize+2 ];
			Array.Copy( sc.RawBoard, this.RawBoard, sc.RawBoard.Length );	// c1 -> c2

			Jx		= new int   [ BoardSize+2, BoardSize+2, BoardSize+2 ];
			Array.Copy( sc.Jx, this.Jx, sc.Jx.Length );	// c1 -> c2

			W	= new int   [ BoardSize+2, BoardSize+2, BoardSize+2 ];
			Array.Copy( sc.W, this.W, sc.W.Length );	// c1 -> c2



			this.Turns			= sc.Turns;
			this.CurrentColor	= sc.CurrentColor;

			this.UpdateLog = (ArrayList)sc.UpdateLog.Clone();

			MaxTurns	=  BoardSize * BoardSize * BoardSize - 8;
			MovablePos	= new ArrayList[ MaxTurns+1 ];
			Array.Copy( sc.MovablePos, this.MovablePos, sc.MovablePos.Length );	// c1 -> c2

			MovableDir	= new int[ MaxTurns+1, BoardSize+2, BoardSize+2, BoardSize+2 ];
			Array.Copy( sc.MovableDir, this.MovableDir, sc.MovableDir.Length );	// c1 -> c2

			this.Discs.set(Disc., sc.Discs.get(Disc.) );
			this.Discs.set(Disc., sc.Discs.get(Disc.) );
			this.Discs.set(Disc., sc.Discs.get(Disc.) );
		}









		/// <summary>
		/// pointŎw肳ꂽʒuɐ΂ł
		/// </summary>
		public bool move(Point point)
		{
			// 1.΂łĂʒu
			if( point.x <= 0 || point.x > BoardSize ) return false;
			if( point.y <= 0 || point.y > BoardSize ) return false;
			if( point.z <= 0 || point.z > BoardSize ) return false;

			if( MovableDir[ Turns, point.x, point.y, point.z ] == iNONE ) return false;
		
			// 2.w肳ꂽʒuɐ΂łAύX_i[
			// 3.MovableDirQƂ΂𗠕ԂBԂWi[
			// 4.ΐ𑝌
			// 5.updateupdateLogɒǉ
			flipDiscs( point );

			// 6.萔AԂ̐FȂǂXV
			Turns++;
			CurrentColor = -CurrentColor;

			// 7.MovableDirMovablePos𒲂ׂȂ
			initMovable();

			return	true;
		}






		/// <summary>
		/// MovablePos[Turns]MovableDir[Turns]ČvZ
		/// </summary>
		private void initMovable()
		{
			Disc	disc;
			int		dir;

			float	BoardSize2 = this.iBOARD_SIZE / 2 + 0.5f;	// Wϊp̒l

			MovablePos[Turns].Clear();

			for( int x = 1; x <= BoardSize; x++ )
			{
				for( int y = 1; y <= BoardSize; y++ )
				{
					for( int z = 1; z <= BoardSize; z++ )
					{
						disc = new Disc( x, y, z, CurrentColor );

						dir = checkMobility( disc, Rule );	// ΂łĂ邩ǂ

						if(dir != iNONE)
						{
							// u
							MovablePos[Turns].Add(disc);
						}

						MovableDir[ Turns, x, y, z ] = dir;
					}
				}
			}
		}







		/// <summary>
		/// Jxݒ
		/// wWɗאڂW̊Jx𑝌B
		///  flipDiscs:-1 undo:+1
		/// </summary>
		private void Jxݒ( int x, int y, int z, int  )
		{
			int	i = ;		// Jx flipDiscs:-1 undo:+1
			
			Jx[x,	y+1,	z  ] = Jx[x,	y+1,	z  ] + i;
			Jx[x,	y+1,	z+1] = Jx[x,	y+1,	z+1] + i;
			Jx[x+1,	y+1,	z+1] = Jx[x+1,	y+1,	z+1] + i;
			Jx[x+1,	y+1,	z  ] = Jx[x+1,	y+1,	z  ] + i;
			Jx[x+1,	y+1,	z-1] = Jx[x+1,	y+1,	z-1] + i;
			Jx[x,	y+1,	z-1] = Jx[x,	y+1,	z-1] + i;
			Jx[x-1,	y+1,	z-1] = Jx[x-1,	y+1,	z-1] + i;
			Jx[x-1,	y+1,	z  ] = Jx[x-1,	y+1,	z  ] + i;
			Jx[x-1,	y+1,	z+1] = Jx[x-1,	y+1,	z+1] + i;

			Jx[x,	y,		z+1] = Jx[x,	y,		z+1] + i;
			Jx[x+1,	y,		z+1] = Jx[x+1,	y,		z+1] + i;
			Jx[x+1,	y,		z  ] = Jx[x+1,	y,		z  ] + i;
			Jx[x+1,	y,		z-1] = Jx[x+1,	y,		z-1] + i;
			Jx[x,	y,		z-1] = Jx[x,	y,		z-1] + i;
			Jx[x-1,	y,		z-1] = Jx[x-1,	y,		z-1] + i;
			Jx[x-1,	y,		z  ] = Jx[x-1,	y,		z  ] + i;
			Jx[x-1,	y,		z+1] = Jx[x-1,	y,		z+1] + i;

			Jx[x,	y-1,	z  ] = Jx[x,	y-1,	z  ] + i;
			Jx[x,	y-1,	z+1] = Jx[x,	y-1,	z+1] + i;
			Jx[x+1,	y-1,	z+1] = Jx[x+1,	y-1,	z+1] + i;
			Jx[x+1,	y-1,	z  ] = Jx[x+1,	y-1,	z  ] + i;
			Jx[x+1,	y-1,	z-1] = Jx[x+1,	y-1,	z-1] + i;
			Jx[x,	y-1,	z-1] = Jx[x,	y-1,	z-1] + i;
			Jx[x-1,	y-1,	z-1] = Jx[x-1,	y-1,	z-1] + i;
			Jx[x-1,	y-1,	z  ] = Jx[x-1,	y-1,	z  ] + i;
			Jx[x-1,	y-1,	z+1] = Jx[x-1,	y-1,	z+1] + i;
		}

		/// <summary>
		/// Jx擾
		/// wW̊Jx擾
		/// </summary>
		public int Jx擾( Point point )
		{
			return this.Jx[point.x, point.y, point.z];
		}




		/// <summary>
		/// pointŎw肳ꂽʒuɐ΂łAݍ߂邷ׂĂ̐΂𗠕ԂB
		/// uł΁vƁuԂ΁vUpdateLogɑ}
		/// </summary>
		private void flipDiscs( Point point )
		{
			int x, y, z;
			int dir = MovableDir[ Turns, point.x, point.y, point.z ];

			ArrayList	update = new ArrayList();

			RawBoard[ point.x, point.y, point.z ] = CurrentColor;
			update.Add( new Disc(point.x, point.y, point.z, CurrentColor) );

			Jxݒ( point.x, point.y, point.z,-1 );	// wWɗאڂW̊JxB

			// --------
			// i	x;	y+;	z;
			if(( dir & i ) != iNONE)
			{
				x = point.x;
				y = point.y;
				z = point.z;

				while( RawBoard[ x, ++y, z ] != CurrentColor )
				{
					RawBoard[x,y,z] = CurrentColor;		// }EXI[o}[N̎A̍WɃ}[N
					update.Add( new Disc(x,y,z, CurrentColor) );
				}
			}

			
			// --------
			// i0000	x;	y+;	z+;
			if(( dir & i0000 ) != iNONE)
			{
				x = point.x;
				y = point.y;
				z = point.z;

				while( RawBoard[ x, ++y, ++z ] != CurrentColor )
				{
					RawBoard[x,y,z] = CurrentColor;
					update.Add( new Disc(x,y,z, CurrentColor) );
				}
			}

			// --------
			// i0130	x+;	y+;	z+;	
			if(( dir & i0130 ) != iNONE)
			{
				x = point.x;
				y = point.y;
				z = point.z;

				while( RawBoard[ ++x, ++y, ++z ] != CurrentColor )
				{
					RawBoard[x,y,z] = CurrentColor;
					update.Add( new Disc(x,y,z, CurrentColor) );
				}
			}

			
			// --------
			// i0300	x+;	y+;	z;	
			if(( dir & i0300 ) != iNONE)
			{
				x = point.x;
				y = point.y;
				z = point.z;

				while( RawBoard[ ++x, ++y, z ] != CurrentColor )
				{
					RawBoard[x,y,z] = CurrentColor;
					update.Add( new Disc(x,y,z, CurrentColor) );
				}
			}

			// --------
			// i0430	x+;	y+;	z-;	
			if(( dir & i0430 ) != iNONE)
			{
				x = point.x;
				y = point.y;
				z = point.z;

				while( RawBoard[ ++x, ++y, --z ] != CurrentColor )
				{
					RawBoard[x,y,z] = CurrentColor;
					update.Add( new Disc(x,y,z, CurrentColor) );
				}
			}

			// --------
			// i0600	x;	y+;	z-;	
			if(( dir & i0600 ) != iNONE)
			{
				x = point.x;
				y = point.y;
				z = point.z;

				while( RawBoard[ x, ++y, --z ] != CurrentColor )
				{
					RawBoard[x,y,z] = CurrentColor;
					update.Add( new Disc(x,y,z, CurrentColor) );
				}
			}

			// --------
			// i0730	x-;	y+;	z-;	
			if(( dir & i0730 ) != iNONE)
			{
				x = point.x;
				y = point.y;
				z = point.z;

				while( RawBoard[ --x, ++y, --z ] != CurrentColor )
				{
					RawBoard[x,y,z] = CurrentColor;
					update.Add( new Disc(x,y,z, CurrentColor) );
				}
			}

			// --------
			// i0900	x-;	y+;	z;	
			if(( dir & i0900 ) != iNONE)
			{
				x = point.x;
				y = point.y;
				z = point.z;

				while( RawBoard[ --x, ++y, z ] != CurrentColor )
				{
					RawBoard[x,y,z] = CurrentColor;
					update.Add( new Disc(x,y,z, CurrentColor) );
				}
			}

			// --------
			// i1030	x-;	y+;	z+;	
			if(( dir & i1030 ) != iNONE)
			{
				x = point.x;
				y = point.y;
				z = point.z;

				while( RawBoard[ --x, ++y, ++z ] != CurrentColor )
				{
					RawBoard[x,y,z] = CurrentColor;
					update.Add( new Disc(x,y,z, CurrentColor) );
				}
			}

			// --------
			// i0000	x;	y;	z+;	
			if(( dir & i0000 ) != iNONE)
			{
				x = point.x;
				y = point.y;
				z = point.z;

				while( RawBoard[ x, y, ++z ] != CurrentColor )
				{
					RawBoard[x,y,z] = CurrentColor;
					update.Add( new Disc(x,y,z, CurrentColor) );
				}
			}

			// --------
			// i0130	x+;	y;	z+;	
			if(( dir & i0130 ) != iNONE)
			{
				x = point.x;
				y = point.y;
				z = point.z;

				while( RawBoard[ ++x, y, ++z ] != CurrentColor )
				{
					RawBoard[x,y,z] = CurrentColor;
					update.Add( new Disc(x,y,z, CurrentColor) );
				}
			}

			// --------
			// i0300	x+;	y;	z;	
			if(( dir & i0300 ) != iNONE)
			{
				x = point.x;
				y = point.y;
				z = point.z;

				while( RawBoard[ ++x, y, z ] != CurrentColor )
				{
					RawBoard[x,y,z] = CurrentColor;
					update.Add( new Disc(x,y,z, CurrentColor) );
				}
			}

			// --------
			// i0430	x+;	y;	z-;	
			if(( dir & i0430 ) != iNONE)
			{
				x = point.x;
				y = point.y;
				z = point.z;

				while( RawBoard[ ++x, y, --z ] != CurrentColor )
				{
					RawBoard[x,y,z] = CurrentColor;
					update.Add( new Disc(x,y,z, CurrentColor) );
				}
			}

			// --------
			// i0600	x;	y;	z-;	
			if(( dir & i0600 ) != iNONE)
			{
				x = point.x;
				y = point.y;
				z = point.z;

				while( RawBoard[ x, y, --z ] != CurrentColor )
				{
					RawBoard[x,y,z] = CurrentColor;
					update.Add( new Disc(x,y,z, CurrentColor) );
				}
			}

			// --------
			// i0730	x-;	y;	z-;	
			if(( dir & i0730 ) != iNONE)
			{
				x = point.x;
				y = point.y;
				z = point.z;

				while( RawBoard[ --x, y, --z ] != CurrentColor )
				{
					RawBoard[x,y,z] = CurrentColor;
					update.Add( new Disc(x,y,z, CurrentColor) );
				}
			}

			// --------
			// i0900	x-;	y;	z;	
			if(( dir & i0900 ) != iNONE)
			{
				x = point.x;
				y = point.y;
				z = point.z;

				while( RawBoard[ --x, y, z ] != CurrentColor )
				{
					RawBoard[x,y,z] = CurrentColor;
					update.Add( new Disc(x,y,z, CurrentColor) );
				}
			}

			// --------
			// i1030	x-;	y;	z+;	
			if(( dir & i1030 ) != iNONE)
			{
				x = point.x;
				y = point.y;
				z = point.z;

				while( RawBoard[ --x, y, ++z ] != CurrentColor )
				{
					RawBoard[x,y,z] = CurrentColor;
					update.Add( new Disc(x,y,z, CurrentColor) );
				}
			}

			// --------
			// i		x;	y-;	z;
			if(( dir & i ) != iNONE)
			{
				x = point.x;
				y = point.y;
				z = point.z;

				while( RawBoard[ x, --y, z ] != CurrentColor )
				{
					RawBoard[x,y,z] = CurrentColor;
					update.Add( new Disc(x,y,z, CurrentColor) );
				}
			}

			// --------
			// i0000	x;	y-;	z+;	
			if(( dir & i0000 ) != iNONE)
			{
				x = point.x;
				y = point.y;
				z = point.z;

				while( RawBoard[ x, --y, ++z ] != CurrentColor )
				{
					RawBoard[x,y,z] = CurrentColor;
					update.Add( new Disc(x,y,z, CurrentColor) );
				}
			}

			// --------
			// i0130	x+;	y-;	z+;	
			if(( dir & i0130 ) != iNONE)
			{
				x = point.x;
				y = point.y;
				z = point.z;

				while( RawBoard[ ++x, --y, ++z ] != CurrentColor )
				{
					RawBoard[x,y,z] = CurrentColor;
					update.Add( new Disc(x,y,z, CurrentColor) );
				}
			}

			// --------
			// i0300	x+;	y-;	z;	
			if(( dir & i0300 ) != iNONE)
			{
				x = point.x;
				y = point.y;
				z = point.z;

				while( RawBoard[ ++x, --y, z ] != CurrentColor )
				{
					RawBoard[x,y,z] = CurrentColor;
					update.Add( new Disc(x,y,z, CurrentColor) );
				}
			}

			// --------
			// i0430	x+;	y-;	z-;	
			if(( dir & i0430 ) != iNONE)
			{
				x = point.x;
				y = point.y;
				z = point.z;

				while( RawBoard[ ++x, --y, --z ] != CurrentColor )
				{
					RawBoard[x,y,z] = CurrentColor;
					update.Add( new Disc(x,y,z, CurrentColor) );
				}
			}

			// --------
			// i0600	x;	y-;	z-;	
			if(( dir & i0600 ) != iNONE)
			{
				x = point.x;
				y = point.y;
				z = point.z;

				while( RawBoard[ x, --y, --z ] != CurrentColor )
				{
					RawBoard[x,y,z] = CurrentColor;
					update.Add( new Disc(x,y,z, CurrentColor) );
				}
			}

			// --------
			// i0730	x-;	y-;	z-;	
			if(( dir & i0730 ) != iNONE)
			{
				x = point.x;
				y = point.y;
				z = point.z;

				while( RawBoard[ --x, --y, --z ] != CurrentColor )
				{
					RawBoard[x,y,z] = CurrentColor;
					update.Add( new Disc(x,y,z, CurrentColor) );
				}
			}

			// --------
			// i0900	x-;	y-;	z;	
			if(( dir & i0900 ) != iNONE)
			{
				x = point.x;
				y = point.y;
				z = point.z;

				while( RawBoard[ --x, --y, z ] != CurrentColor )
				{
					RawBoard[x,y,z] = CurrentColor;
					update.Add( new Disc(x,y,z, CurrentColor) );
				}
			}

			// --------
			// i1030	x-;	y-;	z+;	
			if(( dir & i1030 ) != iNONE)
			{
				x = point.x;
				y = point.y;
				z = point.z;

				while( RawBoard[ --x, --y, ++z ] != CurrentColor )
				{
					RawBoard[x,y,z] = CurrentColor;
					update.Add( new Disc(x,y,z, CurrentColor) );
				}
			}



			// ΂̐XV()
			int discdiff = update.Count;

			Discs.set( CurrentColor, Discs.get( CurrentColor) +  discdiff );
			Discs.set(-CurrentColor, Discs.get(-CurrentColor) - (discdiff - 1) );
			Discs.set( Disc.,      Discs.get( Disc. ) - 1);						// 󂫃}X
		
			UpdateLog.Add( update );
		}






		// --------------------------------------------
		// --------------------------------------------
		/// <summary>
		/// ΂uWɃ}EXI[oŕς΂}[N
		/// </summary>
		private void Mk}EXI[o( Point point )
		{
			// OƓȂBČvZȂėǂ!!
			if( point == Last}EXI[o|Cg )
			{
				return;
			}
			Last}EXI[o|Cg = point;

			int x, y, z;

			int dir = MovableDir[ Turns, point.x, point.y, point.z ];

			MkMouseOver.Clear();	// }EXI[ǒʕς΂i[

			// --------
			// i	x;	y+;	z;
			if(( dir & i ) != iNONE)
			{
				x = point.x; y = point.y; z = point.z;

				while( RawBoard[ x, ++y, z ] != CurrentColor )
				{
					MkMouseOver.Add( new Point(x,y,z) );	// }EXI[o}[N̎A̍WɃ}[N
				}
			}

			// --------
			// i0000	x;	y+;	z+;
			if(( dir & i0000 ) != iNONE)
			{
				x = point.x; y = point.y; z = point.z;

				while( RawBoard[ x, ++y, ++z ] != CurrentColor )
				{
					MkMouseOver.Add( new Point(x,y,z) );	// }EXI[o}[N̎A̍WɃ}[N
				}
			}

			// --------
			// i0130	x+;	y+;	z+;	
			if(( dir & i0130 ) != iNONE)
			{
				x = point.x; y = point.y; z = point.z;

				while( RawBoard[ ++x, ++y, ++z ] != CurrentColor )
				{
					MkMouseOver.Add( new Point(x,y,z) );	// }EXI[o}[N̎A̍WɃ}[N
				}
			}

			// --------
			// i0300	x+;	y+;	z;	
			if(( dir & i0300 ) != iNONE)
			{
				x = point.x; y = point.y; z = point.z;

				while( RawBoard[ ++x, ++y, z ] != CurrentColor )
				{
					MkMouseOver.Add( new Point(x,y,z) );	// }EXI[o}[N̎A̍WɃ}[N
				}
			}

			// --------
			// i0430	x+;	y+;	z-;	
			if(( dir & i0430 ) != iNONE)
			{
				x = point.x; y = point.y; z = point.z;

				while( RawBoard[ ++x, ++y, --z ] != CurrentColor )
				{
					MkMouseOver.Add( new Point(x,y,z) );	// }EXI[o}[N̎A̍WɃ}[N
				}
			}

			// --------
			// i0600	x;	y+;	z-;	
			if(( dir & i0600 ) != iNONE)
			{
				x = point.x; y = point.y; z = point.z;

				while( RawBoard[ x, ++y, --z ] != CurrentColor )
				{
					MkMouseOver.Add( new Point(x,y,z) );	// }EXI[o}[N̎A̍WɃ}[N
				}
			}

			// --------
			// i0730	x-;	y+;	z-;	
			if(( dir & i0730 ) != iNONE)
			{
				x = point.x; y = point.y; z = point.z;

				while( RawBoard[ --x, ++y, --z ] != CurrentColor )
				{
					MkMouseOver.Add( new Point(x,y,z) );	// }EXI[o}[N̎A̍WɃ}[N
				}
			}

			// --------
			// i0900	x-;	y+;	z;	
			if(( dir & i0900 ) != iNONE)
			{
				x = point.x; y = point.y; z = point.z;

				while( RawBoard[ --x, ++y, z ] != CurrentColor )
				{
					MkMouseOver.Add( new Point(x,y,z) );	// }EXI[o}[N̎A̍WɃ}[N
				}
			}

			// --------
			// i1030	x-;	y+;	z+;	
			if(( dir & i1030 ) != iNONE)
			{
				x = point.x; y = point.y; z = point.z;

				while( RawBoard[ --x, ++y, ++z ] != CurrentColor )
				{
					MkMouseOver.Add( new Point(x,y,z) );	// }EXI[o}[N̎A̍WɃ}[N
				}
			}

			// --------
			// i0000	x;	y;	z+;	
			if(( dir & i0000 ) != iNONE)
			{
				x = point.x; y = point.y; z = point.z;

				while( RawBoard[ x, y, ++z ] != CurrentColor )
				{
					MkMouseOver.Add( new Point(x,y,z) );	// }EXI[o}[N̎A̍WɃ}[N
				}
			}

			// --------
			// i0130	x+;	y;	z+;	
			if(( dir & i0130 ) != iNONE)
			{
				x = point.x; y = point.y; z = point.z;

				while( RawBoard[ ++x, y, ++z ] != CurrentColor )
				{
					MkMouseOver.Add( new Point(x,y,z) );	// }EXI[o}[N̎A̍WɃ}[N
				}
			}

			// --------
			// i0300	x+;	y;	z;	
			if(( dir & i0300 ) != iNONE)
			{
				x = point.x; y = point.y; z = point.z;

				while( RawBoard[ ++x, y, z ] != CurrentColor )
				{
					MkMouseOver.Add( new Point(x,y,z) );	// }EXI[o}[N̎A̍WɃ}[N
				}
			}

			// --------
			// i0430	x+;	y;	z-;	
			if(( dir & i0430 ) != iNONE)
			{
				x = point.x; y = point.y; z = point.z;

				while( RawBoard[ ++x, y, --z ] != CurrentColor )
				{
					MkMouseOver.Add( new Point(x,y,z) );	// }EXI[o}[N̎A̍WɃ}[N
				}
			}

			// --------
			// i0600	x;	y;	z-;	
			if(( dir & i0600 ) != iNONE)
			{
				x = point.x; y = point.y; z = point.z;

				while( RawBoard[ x, y, --z ] != CurrentColor )
				{
					MkMouseOver.Add( new Point(x,y,z) );	// }EXI[o}[N̎A̍WɃ}[N
				}
			}

			// --------
			// i0730	x-;	y;	z-;	
			if(( dir & i0730 ) != iNONE)
			{
				x = point.x; y = point.y; z = point.z;

				while( RawBoard[ --x, y, --z ] != CurrentColor )
				{
					MkMouseOver.Add( new Point(x,y,z) );	// }EXI[o}[N̎A̍WɃ}[N
				}
			}

			// --------
			// i0900	x-;	y;	z;	
			if(( dir & i0900 ) != iNONE)
			{
				x = point.x; y = point.y; z = point.z;

				while( RawBoard[ --x, y, z ] != CurrentColor )
				{
					MkMouseOver.Add( new Point(x,y,z) );	// }EXI[o}[N̎A̍WɃ}[N
				}
			}

			// --------
			// i1030	x-;	y;	z+;	
			if(( dir & i1030 ) != iNONE)
			{
				x = point.x; y = point.y; z = point.z;

				while( RawBoard[ --x, y, ++z ] != CurrentColor )
				{
					MkMouseOver.Add( new Point(x,y,z) );	// }EXI[o}[N̎A̍WɃ}[N
				}
			}

			// --------
			// i		x;	y-;	z;
			if(( dir & i ) != iNONE)
			{
				x = point.x; y = point.y; z = point.z;

				while( RawBoard[ x, --y, z ] != CurrentColor )
				{
					MkMouseOver.Add( new Point(x,y,z) );	// }EXI[o}[N̎A̍WɃ}[N
				}
			}

			// --------
			// i0000	x;	y-;	z+;	
			if(( dir & i0000 ) != iNONE)
			{
				x = point.x; y = point.y; z = point.z;

				while( RawBoard[ x, --y, ++z ] != CurrentColor )
				{
					MkMouseOver.Add( new Point(x,y,z) );	// }EXI[o}[N̎A̍WɃ}[N
				}
			}

			// --------
			// i0130	x+;	y-;	z+;	
			if(( dir & i0130 ) != iNONE)
			{
				x = point.x; y = point.y; z = point.z;

				while( RawBoard[ ++x, --y, ++z ] != CurrentColor )
				{
					MkMouseOver.Add( new Point(x,y,z) );	// }EXI[o}[N̎A̍WɃ}[N
				}
			}

			// --------
			// i0300	x+;	y-;	z;	
			if(( dir & i0300 ) != iNONE)
			{
				x = point.x; y = point.y; z = point.z;

				while( RawBoard[ ++x, --y, z ] != CurrentColor )
				{
					MkMouseOver.Add( new Point(x,y,z) );	// }EXI[o}[N̎A̍WɃ}[N
				}
			}

			// --------
			// i0430	x+;	y-;	z-;	
			if(( dir & i0430 ) != iNONE)
			{
				x = point.x; y = point.y; z = point.z;

				while( RawBoard[ ++x, --y, --z ] != CurrentColor )
				{
					MkMouseOver.Add( new Point(x,y,z) );	// }EXI[o}[N̎A̍WɃ}[N
				}
			}

			// --------
			// i0600	x;	y-;	z-;	
			if(( dir & i0600 ) != iNONE)
			{
				x = point.x; y = point.y; z = point.z;

				while( RawBoard[ x, --y, --z ] != CurrentColor )
				{
					MkMouseOver.Add( new Point(x,y,z) );	// }EXI[o}[N̎A̍WɃ}[N
				}
			}

			// --------
			// i0730	x-;	y-;	z-;	
			if(( dir & i0730 ) != iNONE)
			{
				x = point.x; y = point.y; z = point.z;

				while( RawBoard[ --x, --y, --z ] != CurrentColor )
				{
					MkMouseOver.Add( new Point(x,y,z) );	// }EXI[o}[N̎A̍WɃ}[N
				}
			}

			// --------
			// i0900	x-;	y-;	z;	
			if(( dir & i0900 ) != iNONE)
			{
				x = point.x; y = point.y; z = point.z;

				while( RawBoard[ --x, --y, z ] != CurrentColor )
				{
					MkMouseOver.Add( new Point(x,y,z) );	// }EXI[o}[N̎A̍WɃ}[N
				}
			}

			// --------
			// i1030	x-;	y-;	z+;	
			if(( dir & i1030 ) != iNONE)
			{
				x = point.x; y = point.y; z = point.z;

				while( RawBoard[ --x, --y, ++z ] != CurrentColor )
				{
					MkMouseOver.Add( new Point(x,y,z) );	// }EXI[o}[N̎A̍WɃ}[N
				}
			}
		}
		// --------------------------------------------
		// --------------------------------------------



























		/// <summary>
		/// Q[I̔
		/// true:Q[I
		/// </summary>
		public bool isGameOver()
		{
			// MaxTurnsɒBĂQ[I
			if( Turns == MaxTurns ) return true;
		
			// łĂ肪ȂQ[Ił͂Ȃ
			if( MovablePos[Turns].Count != 0 ) return false;
		
			//	݂̎ԂƋt̐FłĂ邩ǂׂ
			Disc	disc = new Disc();
			disc.F = -CurrentColor;

			for( int x=1; x <= BoardSize; x++ )
			{
				disc.x = x;

				for( int y=1; y <= BoardSize; y++ )
				{
					disc.y = y;

					for( int z=1; z <= BoardSize; z++ )
					{
						disc.z = z;

						// uӏ1ł΃Q[Ił͂Ȃ
						if( checkMobility( disc, Rule ) != iNONE ) return false;
					}
				}
			}

			return true;
		}







		/// <summary>
		/// pX
		/// </summary>
		public bool pass()
		{
			// ł肪΃pXłȂ
			if( MovablePos[Turns].Count != 0 ) return false;
		
			// Q[IĂȂApXłȂ
			if( isGameOver() ) return false;

			CurrentColor = -CurrentColor;
		
			UpdateLog.Add( new ArrayList() );	// updateUpdateLogɑ}

			initMovable();
		
			return true;
		}















		/// <summary>
		/// 1O̎̏Ԃɖ߂
		/// Öɖ߂B
		/// true
		/// ɖ߂ȂꍇAȂ킿܂łĂȂꍇfalse
		/// </summary>
		public bool undo()
		{
			// Q[Jn_Ȃ߂Ȃ
			if( Turns == 0 )return false;

			CurrentColor = -CurrentColor;

			// Ō̗vfԂ(߂l:폜ꂽvf )
			ArrayList	update = new ArrayList();
			update.Add( UpdateLog[ UpdateLog.Count-1 ] );
			UpdateLog.RemoveAt( UpdateLog.Count-1 );

			ArrayList	pointAL = (ArrayList)update[0];

			// -----------------------------------------------------
			// O񂪃pXǂŏꍇ
			if( pointAL.Count == 0 )
			{
				// O̓pX

				// MovablePosyMovableDirč\z
				MovablePos[Turns].Clear();
				for( int x=1; x<=BoardSize; x++ )
				{
					for( int y=1; y<=BoardSize; y++ )
					{
						for( int z=1; z<=BoardSize; z++ )
						{
							// SẴ}XiNONEݒ
							MovableDir[Turns,x,y,z] = iNONE;
						}
					}
				}
			}
			else
			{
				// O̓pXłȂ

				Turns--;

				// ΂ɖ߂
				Point p = (Point)pointAL[0];

				RawBoard[ p.x, p.y, p.z ] = Disc.;

				Jxݒ( p.x, p.y, p.z, 1 );	// undoɂwW̊Jx߂B

				for( int i = 1; i < pointAL.Count; i++)
				{
					p = (Point) pointAL[i];
					RawBoard[ p.x, p.y, p.z ] = -CurrentColor;
				}

				// ΐ̍XV
				int discdiff = pointAL.Count;
				int	c = Discs.get( CurrentColor) -  discdiff;
				Discs.set( CurrentColor, Discs.get( CurrentColor) - (discdiff     ) );
				Discs.set(-CurrentColor, Discs.get(-CurrentColor) + (discdiff - 1 ) );

				Discs.set( Disc.,      Discs.get(Disc.) + 1);
			}
			// -----------------------------------------------------

			return true;
		}





















		/// <summary>
		/// {[hQ[Jn̏Ԃɂ
		/// </summary>
		public void init()
		{
			// 1.S}Xǂɐݒ
			for(int x=0; x <= BoardSize+1; x++)
			{
				for(int y=0; y <= BoardSize+1; y++)
				{
					for(int z=0; z <= BoardSize+1; z++)
					{
						RawBoard[x,y,z] = Disc.;
					}
				}
			}

			// 2.󂫃}Xݒ
			for(int x=1; x <= BoardSize; x++)
			{
				for(int y=1; y <= BoardSize; y++)
				{
					for(int z=1; z <= BoardSize; z++)
					{
						RawBoard[x,y,z] = Disc.;
					}
				}
			}


			// Jx
			for(int x=0; x <= BoardSize+1; x++)
			{
				for(int y=0; y <= BoardSize+1; y++)
				{
					for(int z=0; z <= BoardSize+1; z++)
					{
						Jx[x,y,z] = 0;
					}
				}
			}

		// ----------------------------------
		{
			// zu(BoardSize=6/8)
			int	x,y,z;

			if( 8 == BoardSize)	// 3(BoardSize=8)
			{
				x=4; y=4; z=4; RawBoard[x,y,z] = Disc.; Jxݒ( x,y,z,-1);
				x=5; y=5; z=4; RawBoard[x,y,z] = Disc.; Jxݒ( x,y,z,-1);
				x=4; y=5; z=5; RawBoard[x,y,z] = Disc.; Jxݒ( x,y,z,-1);
				x=5; y=4; z=5; RawBoard[x,y,z] = Disc.; Jxݒ( x,y,z,-1);

				// ------------
				x=4; y=5; z=4; RawBoard[x,y,z] = Disc.; Jxݒ( x,y,z,-1);
				x=5; y=4; z=4; RawBoard[x,y,z] = Disc.; Jxݒ( x,y,z,-1);
				x=4; y=4; z=5; RawBoard[x,y,z] = Disc.; Jxݒ( x,y,z,-1);
				x=5; y=5; z=5; RawBoard[x,y,z] = Disc.; Jxݒ( x,y,z,-1);
			}
			else if( 6 == BoardSize)	// 3(BoardSize=6)
			{
				x=3; y=3; z=3; RawBoard[x,y,z] = Disc.; Jxݒ( x,y,z,-1);
				x=4; y=4; z=3; RawBoard[x,y,z] = Disc.; Jxݒ( x,y,z,-1);
				x=3; y=4; z=4; RawBoard[x,y,z] = Disc.; Jxݒ( x,y,z,-1);
				x=4; y=3; z=4; RawBoard[x,y,z] = Disc.; Jxݒ( x,y,z,-1);

				// ------------
				x=3; y=4; z=3; RawBoard[x,y,z] = Disc.; Jxݒ( x,y,z,-1);
				x=4; y=3; z=3; RawBoard[x,y,z] = Disc.; Jxݒ( x,y,z,-1);
				x=3; y=3; z=4; RawBoard[x,y,z] = Disc.; Jxݒ( x,y,z,-1);
				x=4; y=4; z=4; RawBoard[x,y,z] = Disc.; Jxݒ( x,y,z,-1);
			}
			else if( 4 == BoardSize)	// 3(BoardSize=4)
			{
				x=2; y=2; z=2; RawBoard[x,y,z] = Disc.; Jxݒ( x,y,z,-1);
				x=3; y=3; z=2; RawBoard[x,y,z] = Disc.; Jxݒ( x,y,z,-1);
				x=2; y=3; z=3; RawBoard[x,y,z] = Disc.; Jxݒ( x,y,z,-1);
				x=3; y=2; z=3; RawBoard[x,y,z] = Disc.; Jxݒ( x,y,z,-1);

				// ------------
				x=2; y=3; z=2; RawBoard[x,y,z] = Disc.; Jxݒ( x,y,z,-1);
				x=3; y=2; z=2; RawBoard[x,y,z] = Disc.; Jxݒ( x,y,z,-1);
				x=2; y=2; z=3; RawBoard[x,y,z] = Disc.; Jxݒ( x,y,z,-1);
				x=3; y=3; z=3; RawBoard[x,y,z] = Disc.; Jxݒ( x,y,z,-1);
			}

/*
			// 2
			x=4; y=4; z=8; RawBoard[x,y,z] = Disc.; Jxݒ( x,y,z,-1);
			x=5; y=5; z=8; RawBoard[x,y,z] = Disc.; Jxݒ( x,y,z,-1);

			// ------------
			x=5; y=4; z=8; RawBoard[x,y,z] = Disc.; Jxݒ( x,y,z,-1);
			x=4; y=5; z=8; RawBoard[x,y,z] = Disc.; Jxݒ( x,y,z,-1);
*/	
		}
		// ----------------------------------

			// ΐ̏ݒ
			Discs.set(Disc., 4);
			Discs.set(Disc., 4);
			Discs.set(Disc., BoardSize * BoardSize * BoardSize - 8 ); // 8=+(4+4)

			Turns = 0; // 萔0琔
			CurrentColor = Disc.; // ͍

			this.UpdateLog.Clear();
			initMovable();
		}

















		/// <summary>
		/// w肵W̐΂̐F𒲂ׂ
		/// pointŎw肳ꂽʒu̐FԂB
		/// </summary>
		public int getColor( Point point )
		{
			return RawBoard[ point.x, point.y, point.z ];
		}




		/// <summary>
		/// w肳ꂽ΂̌Ԃ
		/// </summary>
		public int countDisc(int color)
		{
			return Discs.get(color);
		}



		/// <summary>
		/// ݂̎Ԃ̐FԂ
		/// </summary>
		public int getCurrentColor()
		{
			return CurrentColor;
		}



		/// <summary>
		/// O̎ŕԂꂽ΂ArrayList(vector)Ԃ
		/// </summary>
//		public Vector getUpdate()
		public ArrayList getUpdate()
		{
			if( UpdateLog.Count == 0 )	// Q[JnɌĂ΂ꂽꍇAVArrayListԂ
				return new ArrayList();
			else
				return (ArrayList) UpdateLog[ UpdateLog.Count-1 ];
		}



		/// <summary>
		/// ΂łĂWArrayList(vector)Ԃ
		/// </summary>
		public ArrayList getMovablePos()
		{
			return MovablePos[Turns];
		}


		/// <summary>
		/// ݂̎萔Ԃ
		/// </summary>
		public int getTurns()
		{
			return Turns;
		}
		


		






		/// <summary>
		/// ΂łĂ邩ǂ
		/// 26 (΂ߕ܂)
		///  6 (xyz) w\
		/// </summary>
		private int checkMobility( Disc disc, int rule )
		{
			/*
			discŎw肳ꂽWɁADisc.color̐F̐΂łĂ邩ǂA܂A
			ǂ̕ɐ΂𗠕Ԃ邩𔻒肷B
			΂𗠕ԂɃtOnԂB
			sw ɂ藠Ԃ̐w
			6    : 6
			6ȊO:26
			*/

			// ɐ΂uȂ
			if( RawBoard[disc.x, disc.y, disc.z] != Disc. ) return iNONE;

			int x, y, z;
			int dir = iNONE;


			// --------
			// i	x;	y+;	z;
			if( RawBoard[disc.x, disc.y+1, disc.z] == -disc.F )
			{
				x = disc.x;
				y = disc.y+2;
				z = disc.z;

				while( RawBoard[x, y, z] == -disc.F ) { y++; }

				if( RawBoard[x, y, z] == disc.F ) dir |= i;
			}

			// --------
			// i0000	x;	y;	z+;	
			if( RawBoard[disc.x, disc.y, disc.z+1] == -disc.F )
			{
				x = disc.x;
				y = disc.y;
				z = disc.z+2;

				while( RawBoard[x, y, z] == -disc.F ) { z++; }

				if( RawBoard[x, y, z] == disc.F ) dir |= i0000;
			}

			// --------
			// i0300	x+;	y;	z;	
			if( RawBoard[disc.x+1, disc.y, disc.z] == -disc.F )
			{
				x = disc.x+2;
				y = disc.y;
				z = disc.z;

				while( RawBoard[x, y, z] == -disc.F ) { x++;  }

				if( RawBoard[x, y, z] == disc.F ) dir |= i0300;
			}

			// --------
			// i0600	x;	y;	z-;	
			if( RawBoard[disc.x, disc.y, disc.z-1] == -disc.F )
			{
				x = disc.x;
				y = disc.y;
				z = disc.z-2;

				while( RawBoard[x, y, z] == -disc.F ) { z--; }

				if( RawBoard[x, y, z] == disc.F ) dir |= i0600;
			}

			// --------
			// i0900	x-;	y;	z;	
			if( RawBoard[disc.x-1, disc.y, disc.z] == -disc.F )
			{
				x = disc.x-2;
				y = disc.y;
				z = disc.z;

				while( RawBoard[x, y, z] == -disc.F ) { x--; }

				if( RawBoard[x, y, z] == disc.F ) dir |= i0900;
			}

			// --------
			// i		x;	y-;	z;
			if( RawBoard[disc.x, disc.y-1, disc.z] == -disc.F )
			{
				x = disc.x;
				y = disc.y-2;
				z = disc.z;

				while( RawBoard[x, y, z] == -disc.F ) { y--; }

				if( RawBoard[x, y, z] == disc.F ) dir |= i;
			}





			// rule := 6()ȊOȂ΂ߕ̔s
			if( 6 != rule )
			{
				// --------
				// i0000	x;	y+;	z+;
				if( RawBoard[disc.x, disc.y+1, disc.z+1] == -disc.F )
				{
					x = disc.x;
					y = disc.y+2;
					z = disc.z+2;

					while( RawBoard[x, y, z] == -disc.F ) { y++; z++; }

					if( RawBoard[x, y, z] == disc.F ) dir |= i0000;
				}

				// --------
				// i0130	x+;	y+;	z+;	
				if( RawBoard[disc.x+1, disc.y+1, disc.z+1] == -disc.F )
				{
					x = disc.x+2;
					y = disc.y+2;
					z = disc.z+2;

					while( RawBoard[x, y, z] == -disc.F ) { x++; y++; z++; }

					if( RawBoard[x, y, z] == disc.F ) dir |= i0130;
				}

				// --------
				// i0300	x+;	y+;	z;	
				if( RawBoard[disc.x+1, disc.y+1, disc.z] == -disc.F )
				{
					x = disc.x+2;
					y = disc.y+2;
					z = disc.z;

					while( RawBoard[x, y, z] == -disc.F ) { x++; y++; }

					if( RawBoard[x, y, z] == disc.F ) dir |= i0300;
				}

				// --------
				// i0430	x+;	y+;	z-;	
				if( RawBoard[disc.x+1, disc.y+1, disc.z-1] == -disc.F )
				{
					x = disc.x+2;
					y = disc.y+2;
					z = disc.z-2;

					while( RawBoard[x, y, z] == -disc.F ) { x++; y++; z--; }

					if( RawBoard[x, y, z] == disc.F ) dir |= i0430;
				}

				// --------
				// i0600	x;	y+;	z-;	
				if( RawBoard[disc.x, disc.y+1, disc.z-1] == -disc.F )
				{
					x = disc.x;
					y = disc.y+2;
					z = disc.z-2;

					while( RawBoard[x, y, z] == -disc.F ) { y++; z--; }

					if( RawBoard[x, y, z] == disc.F ) dir |= i0600;
				}

				// --------
				// i0730	x-;	y+;	z-;	
				if( RawBoard[disc.x-1, disc.y+1, disc.z-1] == -disc.F )
				{
					x = disc.x-2;
					y = disc.y+2;
					z = disc.z-2;

					while( RawBoard[x, y, z] == -disc.F ) { x--; y++; z--; }

					if( RawBoard[x, y, z] == disc.F ) dir |= i0730;
				}

				// --------
				// i0900	x-;	y+;	z;	
				if( RawBoard[disc.x-1, disc.y+1, disc.z] == -disc.F )
				{
					x = disc.x-2;
					y = disc.y+2;
					z = disc.z;

					while( RawBoard[x, y, z] == -disc.F ) { x--; y++; }

					if( RawBoard[x, y, z] == disc.F ) dir |= i0900;
				}

				// --------
				// i1030	x-;	y+;	z+;	
				if( RawBoard[disc.x-1, disc.y+1, disc.z+1] == -disc.F )
				{
					x = disc.x-2;
					y = disc.y+2;
					z = disc.z+2;

					while( RawBoard[x, y, z] == -disc.F ) { x--; y++; z++; }

					if( RawBoard[x, y, z] == disc.F ) dir |= i1030;
				}

				// --------
				// i0130	x+;	y;	z+;	
				if( RawBoard[disc.x+1, disc.y, disc.z+1] == -disc.F )
				{
					x = disc.x+2;
					y = disc.y;
					z = disc.z+2;

					while( RawBoard[x, y, z] == -disc.F ) { x++; z++; }

					if( RawBoard[x, y, z] == disc.F ) dir |= i0130;
				}

				// --------
				// i0430	x+;	y;	z-;	
				if( RawBoard[disc.x+1, disc.y, disc.z-1] == -disc.F )
				{
					x = disc.x+2;
					y = disc.y;
					z = disc.z-2;

					while( RawBoard[x, y, z] == -disc.F ) { x++; z--; }

					if( RawBoard[x, y, z] == disc.F ) dir |= i0430;
				}

				// --------
				// i0730	x-;	y;	z-;	
				if( RawBoard[disc.x-1, disc.y, disc.z-1] == -disc.F )
				{
					x = disc.x-2;
					y = disc.y;
					z = disc.z-2;

					while( RawBoard[x, y, z] == -disc.F ) { x--; z--; }

					if( RawBoard[x, y, z] == disc.F ) dir |= i0730;
				}

				// --------
				// i1030	x-;	y;	z+;	
				if( RawBoard[disc.x-1, disc.y, disc.z+1] == -disc.F )
				{
					x = disc.x-2;
					y = disc.y;
					z = disc.z+2;

					while( RawBoard[x, y, z] == -disc.F ) { x--; z++; }

					if( RawBoard[x, y, z] == disc.F ) dir |= i1030;
				}

				// --------
				// i0000	x;	y-;	z+;	
				if( RawBoard[disc.x, disc.y-1, disc.z+1] == -disc.F )
				{
					x = disc.x;
					y = disc.y-2;
					z = disc.z+2;

					while( RawBoard[x, y, z] == -disc.F ) { y--; z++; }

					if( RawBoard[x, y, z] == disc.F ) dir |= i0000;
				}

				// --------
				// i0130	x+;	y-;	z+;	
				if( RawBoard[disc.x+1, disc.y-1, disc.z+1] == -disc.F )
				{
					x = disc.x+2;
					y = disc.y-2;
					z = disc.z+2;

					while( RawBoard[x, y, z] == -disc.F ) { x++; y--; z++; }

					if( RawBoard[x, y, z] == disc.F ) dir |= i0130;
				}

				// --------
				// i0300	x+;	y-;	z;	
				if( RawBoard[disc.x+1, disc.y-1, disc.z] == -disc.F )
				{
					x = disc.x+2;
					y = disc.y-2;
					z = disc.z;

					while( RawBoard[x, y, z] == -disc.F ) { x++; y--; }

					if( RawBoard[x, y, z] == disc.F ) dir |= i0300;
				}

				// --------
				// i0430	x+;	y-;	z-;	
				if( RawBoard[disc.x+1, disc.y-1, disc.z-1] == -disc.F )
				{
					x = disc.x+2;
					y = disc.y-2;
					z = disc.z-2;

					while( RawBoard[x, y, z] == -disc.F ) { x++; y--; z--; }

					if( RawBoard[x, y, z] == disc.F ) dir |= i0430;
				}

				// --------
				// i0600	x;	y-;	z-;	
				if( RawBoard[disc.x, disc.y-1, disc.z-1] == -disc.F )
				{
					x = disc.x;
					y = disc.y-2;
					z = disc.z-2;

					while( RawBoard[x, y, z] == -disc.F ) { y--; z--; }

					if( RawBoard[x, y, z] == disc.F ) dir |= i0600;
				}

				// --------
				// i0730	x-;	y-;	z-;	
				if( RawBoard[disc.x-1, disc.y-1, disc.z-1] == -disc.F )
				{
					x = disc.x-2;
					y = disc.y-2;
					z = disc.z-2;

					while( RawBoard[x, y, z] == -disc.F ) { x--; y--; z--; }

					if( RawBoard[x, y, z] == disc.F ) dir |= i0730;
				}

				// --------
				// i0900	x-;	y-;	z;	
				if( RawBoard[disc.x-1, disc.y-1, disc.z] == -disc.F )
				{
					x = disc.x-2;
					y = disc.y-2;
					z = disc.z;

					while( RawBoard[x, y, z] == -disc.F ) { x--; y--; }

					if( RawBoard[x, y, z] == disc.F ) dir |= i0900;
				}

				// --------
				// i1030	x-;	y-;	z+;	
				if( RawBoard[disc.x-1, disc.y-1, disc.z+1] == -disc.F )
				{
					x = disc.x-2;
					y = disc.y-2;
					z = disc.z+2;

					while( RawBoard[x, y, z] == -disc.F ) { x--; y--; z++; }

					if( RawBoard[x, y, z] == disc.F ) dir |= i1030;
				}
			}

			return dir;
		}















		// ==========================================================================
		// ==========================================================================



		/// <summary>
		/// 
		/// </summary>
		public void CreateVB( Device device )
		{
			float f;
			f =( ( (float)BoardSize - 1.0f) / 2.0f );// ̃Obh̒S`̒Sɂ邽߂̒l

			// --------------------------------------------------------------------
			// _ɂObh쐬
			vertexBuffer = new VertexBuffer(
				typeof(CustomVertex.PositionOnly),
				iGrid,
				device,
				0,
				CustomVertex.PositionOnly.Format,
				Pool.Default );

			VertexBuffer				vb = (VertexBuffer)vertexBuffer;

			CustomVertex.PositionOnly[]	vertsPO = (CustomVertex.PositionOnly[])vb.Lock(0,0);

			int i = 0;

			for( int x = 0; x < BoardSize; x++ )
			{
				for( int y = 0; y < BoardSize; y++ )
				{
					for( int z = 0; z < BoardSize; z++ )
					{
						vertsPO[i].X = x-f;
						vertsPO[i].Y = y-f;
						vertsPO[i].Z = z-f;
						i++;
					}
				}
			}
			vb.Unlock();


			// --------------------------------------------------------------------
			// ɂOg쐬
			m_SquareBuffer = new VertexBuffer(
				typeof(CustomVertex.PositionOnly),
				18,
				device,
				0,
				CustomVertex.PositionOnly.Format,
				Pool.Default );

			vb		= (VertexBuffer)m_SquareBuffer;
			vertsPO = (CustomVertex.PositionOnly[])vb.Lock(0,0);

			i = 0;

			float	pos = this.iBOARD_SIZE/2;
			vertsPO[i].X = -pos; vertsPO[i].Y = -pos; vertsPO[i].Z = -pos; i++;
			vertsPO[i].X =  pos; vertsPO[i].Y = -pos; vertsPO[i].Z = -pos; i++;
			vertsPO[i].X =  pos; vertsPO[i].Y =  pos; vertsPO[i].Z = -pos; i++;
			vertsPO[i].X = -pos; vertsPO[i].Y =  pos; vertsPO[i].Z = -pos; i++;
			vertsPO[i].X = -pos; vertsPO[i].Y = -pos; vertsPO[i].Z = -pos; i++;

			vertsPO[i].X = -pos; vertsPO[i].Y = -pos; vertsPO[i].Z =  pos; i++;
			vertsPO[i].X =  pos; vertsPO[i].Y = -pos; vertsPO[i].Z =  pos; i++;
			vertsPO[i].X =  pos; vertsPO[i].Y =  pos; vertsPO[i].Z =  pos; i++;
			vertsPO[i].X = -pos; vertsPO[i].Y =  pos; vertsPO[i].Z =  pos; i++;
			vertsPO[i].X = -pos; vertsPO[i].Y = -pos; vertsPO[i].Z =  pos; i++;

			vertsPO[i].X = -pos; vertsPO[i].Y = -pos; vertsPO[i].Z = -pos; i++;
			vertsPO[i].X = -pos; vertsPO[i].Y = -pos; vertsPO[i].Z =  pos; i++;

			vertsPO[i].X =  pos; vertsPO[i].Y = -pos; vertsPO[i].Z = -pos; i++;
			vertsPO[i].X =  pos; vertsPO[i].Y = -pos; vertsPO[i].Z =  pos; i++;

			vertsPO[i].X =  pos; vertsPO[i].Y =  pos; vertsPO[i].Z = -pos; i++;
			vertsPO[i].X =  pos; vertsPO[i].Y =  pos; vertsPO[i].Z =  pos; i++;

			vertsPO[i].X = -pos; vertsPO[i].Y =  pos; vertsPO[i].Z = -pos; i++;
			vertsPO[i].X = -pos; vertsPO[i].Y =  pos; vertsPO[i].Z =  pos; i++;

			vb.Unlock();


			// --------------------------------------------------------------------
			// ɂ}[N쐬
			m_LineBuffer = new VertexBuffer(
				typeof(CustomVertex.PositionColored),
				6,
				device,
				0,
				CustomVertex.PositionColored.Format,
				Pool.Default );

			vb		= (VertexBuffer)m_LineBuffer;

			CustomVertex.PositionColored[]	verts = (CustomVertex.PositionColored[])vb.Lock(0,0);

			i = 0;

			pos = this.iBOARD_SIZE/2;
//x
			int	col = System.Drawing.Color.FromArgb(0xc00000).ToArgb();
			verts[i].X = -pos; verts[i].Y =  0;   verts[i].Z =  0;   verts[i].Color = col; i++;
			verts[i].X =  pos; verts[i].Y =  0;   verts[i].Z =  0;   verts[i].Color = col; i++;
//y
			col = System.Drawing.Color.FromArgb(0x00c000).ToArgb();
			verts[i].X =  0;   verts[i].Y = -pos; verts[i].Z =  0;   verts[i].Color = col; i++;
			verts[i].X =  0;   verts[i].Y =  pos; verts[i].Z =  0;   verts[i].Color = col; i++;
//z
			col = System.Drawing.Color.FromArgb(0x0000c0).ToArgb();
			verts[i].X =  0;   verts[i].Y =  0;   verts[i].Z = -pos; verts[i].Color = col; i++;
			verts[i].X =  0;   verts[i].Y =  0;   verts[i].Z =  pos; verts[i].Color = col; i++;

			vb.Unlock();


			// --------------------------------------------------------------------
			// bV 쐬
			//			m_mesh = Mesh.Sphere( device, 0.25f, 8, 8 );	// 
			/*
			public static Mesh Sphere(
				Device device,
				float	radius, // a
				int		slices,	// XCX
				int		stacks	// X^bN
				// slices,stacks͏cAɂ̐iCj`w
				// 4̏ꍇ4
			);
			*/
			m_mesh			= Mesh.Box( device, 0.3f,  0.3f,  0.3f );	// device,,,[
			m_meshMouseOver	= Mesh.Box( device, 0.1f,  0.1f,  0.1f );	// device,,,[
			m_mesh		= Mesh.Box( device, 0.01f, 0.04f, 0.09f );	// device,,,[

//			m_meshMk		= Mesh.Box( device, 0.4f,  0.4f,  0.4f );	// device,,,[
			m_meshMk		= Mesh.Sphere( device, 0.30f, 6, 6 );		//  }EXI[o
			m_meshLastMk	= Mesh.Sphere( device, 0.25f, 6, 4 );		//  Ōɑłꏊ


			f =( ( (float)BoardSize + 2.0f - 1.0f) / 2.0f );// ̃Obh̒S`̒Sɂ邽߂̒l

			// ===
			for( int x = 1; x <= BoardSize; x++ )
			{
				for( int y = 1; y <= BoardSize; y++ )
				{
					for( int z = 1; z <= BoardSize; z++ )
					{
						m_GridMat[x,y,z] = Matrix.Identity * Matrix.Translation( x-f, y-f, z-f );
					}
				}
			}
			// ===
		}

		
		
		
		/// <summary>
		/// obt@̊J
		/// </summary>
		public void Dispose()
		{
			if( vertexBuffer != null )
			{
				vertexBuffer.Dispose();
			}


			if( m_SquareBuffer != null )
			{
				m_SquareBuffer.Dispose();
			}

			if( m_LineBuffer != null )
			{
				m_LineBuffer.Dispose();
			}


			if( m_mesh != null)
			{
				m_mesh.Dispose();
				m_mesh = null;
			}

			if( m_meshMk != null)
			{
				m_meshMk.Dispose();
				m_meshMk = null;
			}

			if( m_meshLastMk != null)
			{
				m_meshLastMk.Dispose();
				m_meshLastMk = null;
			}

			if( m_meshMouseOver != null)
			{
				m_meshMouseOver.Dispose();
				m_meshMouseOver = null;
			}

			if( m_mesh != null)
			{
				m_mesh.Dispose();
				m_mesh = null;
			}


		}
	
		













		/// <summary>
		/// VF[_gpDraw
		/// </summary>
		public void Draw(	Device device,
							Matrix WorldMatrix, Matrix worldViewProjection,
							int mouseOverX, int mouseOverY,int mouseOverZ,
							Effect effect, bool bW\ )
		{
			int passes;

			try
			{
				device.VertexFormat = CustomVertex.PositionOnly.Format;

				effect.Technique = "RenderPrimitive";	// Primitives\ sɂ閾邳ϊL

				effect.SetValue( "g_MaterialAmbientColor", System.Drawing.Color.White.ToArgb() );
				effect.SetValue( "GridWorldMatrix", Matrix.Identity  );
				// -------------------------------------
				// _Os߂ɁAeffect.BeginPass() Ăяo܂B
				// ̌ĂяóAeNjbNŕKvȃpX̐Ԃ܂B
				passes = effect.Begin(0);
				for (int pass = 0; pass < passes; pass++)
				{
					// ================================
					// effect.BeginPass(iPass) ĂяoĊepX[vA
					effect.BeginPass(pass);

					// -----------------------------------------------------------------
					// bW\ == falsȅꍇ _ŋW\
					if( !bW\ )
					{
						// _ɂObh\
						device.RenderState.FillMode = FillMode.Point;
						device.SetStreamSource( 0, vertexBuffer, 0 );
						device.DrawPrimitives( PrimitiveType.PointList, 0, iGrid );
					}

					// -----------------------------------------------------------------
					// ɂOg\
					device.SetStreamSource( 0, m_SquareBuffer, 0 );
					device.RenderState.FillMode = FillMode.WireFrame;
					device.DrawPrimitives( PrimitiveType.LineStrip, 0, 4 );
					device.DrawPrimitives( PrimitiveType.LineStrip, 5, 4 );
					device.DrawPrimitives( PrimitiveType.LineList, 10, 4 );

					// epX̌ɁAeffect.EndPass Ăяo܂B
					effect.EndPass();
					// ================================
				}
				// ׂẴpXAeffect.End Ăяo܂B
				effect.End();


				// -----------------------------------------------------------------
				// Disc\

				effect.Technique = "RenderMesh";	// Mesh\ Cg/sɂ閾邳ϊL

				device.RenderState.FillMode = FillMode.Solid;	// FillModeݒ

				// 󂫍W \
				// bW\ == truȅꍇ Ft̏ȔŋW\
				if( bW\ )
				{
					for( int x = 1; x <= BoardSize; x++ )
					{
						for( int y = 1; y <= BoardSize; y++ )
						{
							for( int z = 1; z <= BoardSize; z++ )
							{
								if( Disc. == this.getColor(new Point(x, y, z) ) )
								{

									effect.SetValue( "worldViewProjection",	m_GridMat[x,y,z] * worldViewProjection );
									effect.SetValue( "GridWorldMatrix",     m_GridMat[x,y,z] * WorldMatrix );

									// p=2 / pɗא=1 / ȊO=0
									switch( this.W[x,y,z] )
									{
										case 1:		// pɗא=1
											effect.SetValue( "g_MaterialAmbientColor", System.Drawing.Color.Gold.ToArgb() );
											break;
										case 2:		// p=2
											effect.SetValue( "g_MaterialAmbientColor", System.Drawing.Color.OrangeRed.ToArgb() );
											break;
										default:	// pApɗאځAȊO=0
											effect.SetValue( "g_MaterialAmbientColor", System.Drawing.Color.Thistle.ToArgb() );
											break;
									}

									passes = effect.Begin(0);
									for (int pass = 0; pass < passes; pass++)
									{
										effect.BeginPass(pass);

										m_mesh.DrawSubset(0);

										effect.EndPass();
									}
									effect.End();
								}
							}
						}
					}
				}





				//  \
				effect.SetValue( "g_MaterialAmbientColor", System.Drawing.Color.DarkSlateBlue.ToArgb() );

				for( int x = 1; x <= BoardSize; x++ )
				{
					for( int y = 1; y <= BoardSize; y++ )
					{
						for( int z = 1; z <= BoardSize; z++ )
						{
							if( Disc. == this.getColor(new Point(x, y, z) ) )
							{
								effect.SetValue( "worldViewProjection",	m_GridMat[x,y,z] * worldViewProjection );
								effect.SetValue( "GridWorldMatrix",     m_GridMat[x,y,z] * WorldMatrix );

								// -------------------------------------
								// _Os߂ɁAeffect.BeginPass() Ăяo܂B
								// ̌ĂяóAeNjbNŕKvȃpX̐Ԃ܂B
								passes = effect.Begin(0);
								for (int pass = 0; pass < passes; pass++)
								{
									// ================================
									// effect.BeginPass(iPass) ĂяoĊepX[vA
									effect.BeginPass(pass);

									m_mesh.DrawSubset(0);

									// epX̌ɁAeffect.EndPass Ăяo܂B
									effect.EndPass();
									// ================================
								}
								// ׂẴpXAeffect.End Ăяo܂B
								effect.End();
								// -------------------------------------
							}
						}
					}
				}



				//  \
				effect.SetValue( "g_MaterialAmbientColor", System.Drawing.Color.White.ToArgb() );

				for( int x = 1; x <= BoardSize; x++ )
				{
					for( int y = 1; y <= BoardSize; y++ )
					{
						for( int z = 1; z <= BoardSize; z++ )
						{
							if( Disc. == this.getColor(new Point(x, y, z) ) )
							{
								effect.SetValue( "worldViewProjection",	m_GridMat[x,y,z] * worldViewProjection );
								effect.SetValue( "GridWorldMatrix",     m_GridMat[x,y,z] * WorldMatrix );

								// -------------------------------------
								// _Os߂ɁAeffect.BeginPass() Ăяo܂B
								// ̌ĂяóAeNjbNŕKvȃpX̐Ԃ܂B
								passes = effect.Begin(0);
								for (int pass = 0; pass < passes; pass++)
								{
									// ================================
									// effect.BeginPass(iPass) ĂяoĊepX[vA
									effect.BeginPass(pass);

									m_mesh.DrawSubset(0);

									// epX̌ɁAeffect.EndPass Ăяo܂B
									effect.EndPass();
									// ================================
								}
								// ׂẴpXAeffect.End Ăяo܂B
								effect.End();
								// -------------------------------------
							}
						}
					}
				}



				// -----------------------------------------------------------------
				// łĂW\ (MovablePos)
				// W p / pɗא / ȊO ŕ\Fς

				// FillModeݒ
				device.RenderState.FillMode = FillMode.WireFrame;

				ArrayList posAL = getMovablePos();

				for( int i = 0; i < posAL.Count; i++ )
				{
					Disc	p = (Disc)posAL[i];

					effect.SetValue( "worldViewProjection", m_GridMat[p.x, p.y, p.z] * worldViewProjection );
					effect.SetValue( "GridWorldMatrix",     m_GridMat[p.x, p.y, p.z] * WorldMatrix );

					if( W[p.x, p.y, p.z] == 0)	// p=2 / pɗא=1 / ȊO=0
					{
						effect.SetValue( "g_MaterialAmbientColor", System.Drawing.Color.SpringGreen.ToArgb() );

						passes = effect.Begin(0);
						for (int pass = 0; pass < passes; pass++)
						{
							effect.BeginPass(pass);

							m_mesh.DrawSubset(0);

							effect.EndPass();
						}
						effect.End();
					}
					else if( W[p.x, p.y, p.z] == 2)	// p=2
					{
						effect.SetValue( "g_MaterialAmbientColor", System.Drawing.Color.OrangeRed.ToArgb() );
								
						passes = effect.Begin(0);
						for (int pass = 0; pass < passes; pass++)
						{
							effect.BeginPass(pass);

							m_mesh.DrawSubset(0);

							effect.EndPass();
						}
						effect.End();
					}
					else if( W[p.x, p.y, p.z] == 1)	// pɗא=1
					{
						effect.SetValue( "g_MaterialAmbientColor", System.Drawing.Color.Gold.ToArgb() );
						passes = effect.Begin(0);
						for (int pass = 0; pass < passes; pass++)
						{
							effect.BeginPass(pass);

							m_mesh.DrawSubset(0);

							effect.EndPass();
						}
						effect.End();
					}
				}





				// }EXI[oObh \
				if( (-1 != mouseOverX) && (-1 != mouseOverY) && (-1 != mouseOverZ) )
				{
					// -----------------------------------------------------
					float	f =( ( (float)BoardSize - 1.0f) / 2.0f );// ̃Obh̒S`̒Sɂ邽߂̒l
					float	pos = this.iBOARD_SIZE / 2;

					// ========================================================
					// 1.̕\ (x,y,z)
					effect.Technique = "RenderPrimitive";	// Primitives\ sɂ閾邳ϊL
					device.RenderState.FillMode = FillMode.WireFrame;

					device.SetStreamSource( 0, m_LineBuffer, 0 );

					//////////
					effect.SetValue("g_MaterialAmbientColor", System.Drawing.Color.Red.ToArgb() );
					effect.SetValue("worldViewProjection",	Matrix.Identity * Matrix.Translation( 0, mouseOverY-1-f, mouseOverZ-1-f ) * worldViewProjection );
					passes = effect.Begin(0);
					for (int pass = 0; pass < passes; pass++)
					{
						effect.BeginPass(pass);
						device.DrawPrimitives( PrimitiveType.LineList, 0, 1 );
						effect.EndPass();
					}
					effect.End();

					//////////
					effect.SetValue("g_MaterialAmbientColor", System.Drawing.Color.DeepSkyBlue.ToArgb() );
					effect.SetValue("worldViewProjection",	Matrix.Identity * Matrix.Translation( mouseOverX-1-f, 0, mouseOverZ-1-f ) * worldViewProjection );
					passes = effect.Begin(0);
					for (int pass = 0; pass < passes; pass++)
					{
						effect.BeginPass(pass);
						device.DrawPrimitives( PrimitiveType.LineList, 2, 1 );
						effect.EndPass();
					}
					effect.End();

					//////////
					effect.SetValue("g_MaterialAmbientColor", System.Drawing.Color.Blue.ToArgb() );
					effect.SetValue("worldViewProjection",	Matrix.Identity * Matrix.Translation( mouseOverX-1-f, mouseOverY-1-f, 0 ) * worldViewProjection );
					passes = effect.Begin(0);
					for (int pass = 0; pass < passes; pass++)
					{
						effect.BeginPass(pass);
						device.DrawPrimitives( PrimitiveType.LineList, 4, 1 );
						effect.EndPass();
					}
					effect.End();


					// ========================================================
					// 2.bV\ (x,y,z̗[ɏȔ\)
					effect.Technique = "RenderMesh";	// Mesh\ Cg/sɂ閾邳ϊL
					device.RenderState.FillMode = FillMode.Solid;	// FillModeݒ

					// ̗[ɃbV\
					//////////
					effect.SetValue("g_MaterialAmbientColor", System.Drawing.Color.Red.ToArgb() );

					effect.SetValue("worldViewProjection",	Matrix.Identity * Matrix.Translation(  pos, mouseOverY-1-f, mouseOverZ-1-f ) * worldViewProjection );
					passes = effect.Begin(0);
					for (int pass = 0; pass < passes; pass++)
					{
						effect.BeginPass(pass);
						m_meshMouseOver.DrawSubset(0);
						effect.EndPass();
					}
					effect.End();

					effect.SetValue("worldViewProjection",	Matrix.Identity * Matrix.Translation(  -pos, mouseOverY-1-f, mouseOverZ-1-f ) * worldViewProjection );
					passes = effect.Begin(0);
					for (int pass = 0; pass < passes; pass++)
					{
						effect.BeginPass(pass);
						m_meshMouseOver.DrawSubset(0);
						effect.EndPass();
					}
					effect.End();

					//////////
					effect.SetValue("g_MaterialAmbientColor", System.Drawing.Color.DeepSkyBlue.ToArgb() );

					effect.SetValue("worldViewProjection",	Matrix.Identity * Matrix.Translation(  mouseOverX-1-f,  pos, mouseOverZ-1-f ) * worldViewProjection );
					passes = effect.Begin(0);
					for (int pass = 0; pass < passes; pass++)
					{
						effect.BeginPass(pass);
						m_meshMouseOver.DrawSubset(0);
						effect.EndPass();
					}
					effect.End();

					effect.SetValue("worldViewProjection",	Matrix.Identity * Matrix.Translation(  mouseOverX-1-f,  -pos, mouseOverZ-1-f ) * worldViewProjection );
					passes = effect.Begin(0);
					for (int pass = 0; pass < passes; pass++)
					{
						effect.BeginPass(pass);
						m_meshMouseOver.DrawSubset(0);
						effect.EndPass();
					}
					effect.End();

					//////////
					effect.SetValue("g_MaterialAmbientColor", System.Drawing.Color.Blue.ToArgb() );

					effect.SetValue("worldViewProjection",	Matrix.Identity * Matrix.Translation(  mouseOverX-1-f, mouseOverY-1-f,  pos ) * worldViewProjection );
					passes = effect.Begin(0);
					for (int pass = 0; pass < passes; pass++)
					{
						effect.BeginPass(pass);
						m_meshMouseOver.DrawSubset(0);
						effect.EndPass();
					}
					effect.End();

					effect.SetValue("worldViewProjection",	Matrix.Identity * Matrix.Translation(  mouseOverX-1-f, mouseOverY-1-f,  -pos ) * worldViewProjection );
					passes = effect.Begin(0);
					for (int pass = 0; pass < passes; pass++)
					{
						effect.BeginPass(pass);
						m_meshMouseOver.DrawSubset(0);
						effect.EndPass();
					}
					effect.End();

					// ========================================================
					// 3.}EXI[oObh \bh\
/*
					for( int i = 0; i < posAL.Count; i++ )
					{
						Disc	p = (Disc)posAL[i];

// OƓȂB
this.Mk}EXI[o(p);	// ΂uWɃ}EXI[oŕς΂}[N

						if( (p.x == mouseOverX) && (p.y == mouseOverY) && (p.z == mouseOverZ) )
						{
							// p=2 OrangeRed / pɗא=1 Gold / ȊO=0 SpringGreen
							if( W[p.x, p.y, p.z] == 2 )
								effect.SetValue("g_MaterialAmbientColor", System.Drawing.Color.OrangeRed.ToArgb() );	// p
							else if( W[p.x, p.y, p.z] == 1 )
								effect.SetValue("g_MaterialAmbientColor", System.Drawing.Color.Gold.ToArgb() );			// pɗא
							else
								effect.SetValue("g_MaterialAmbientColor", System.Drawing.Color.SpringGreen.ToArgb() );	// łƂoW
						}
					}
*/
					// p=2 OrangeRed / pɗא=1 Gold / ȊO=0 SpringGreen
					switch( this.W[mouseOverX, mouseOverY, mouseOverZ] )
					{
						case 1:		// pɗא=1
							effect.SetValue( "g_MaterialAmbientColor", System.Drawing.Color.Gold.ToArgb() );
							break;
						case 2:		// p=2
							effect.SetValue( "g_MaterialAmbientColor", System.Drawing.Color.OrangeRed.ToArgb() );
							break;
						default:	// pApɗאځAȊO=0
							effect.SetValue( "g_MaterialAmbientColor", System.Drawing.Color.SpringGreen.ToArgb() );
							break;

					}




					effect.SetValue( "worldViewProjection",	m_GridMat[mouseOverX, mouseOverY, mouseOverZ] * worldViewProjection );
					effect.SetValue( "GridWorldMatrix",     m_GridMat[mouseOverX, mouseOverY, mouseOverZ] * WorldMatrix );

					passes = effect.Begin(0);
					for (int pass = 0; pass < passes; pass++)
					{
						effect.BeginPass(pass);
						m_mesh.DrawSubset(0);
						effect.EndPass();
					}
					effect.End();



					device.RenderState.FillMode = FillMode.WireFrame;

					this.Mk}EXI[o( new Point(mouseOverX, mouseOverY, mouseOverZ) );	// ΂uWɃ}EXI[oŕς΂}[N

					// -----------------------------------------------------------------
					// }EXI[oŕςW\

					for( int i = 0; i < MkMouseOver.Count; i++ )
					{
						Point	p = (Point)MkMouseOver[i];

						effect.SetValue( "worldViewProjection", m_GridMat[p.x, p.y, p.z] * worldViewProjection );
						effect.SetValue( "GridWorldMatrix",     m_GridMat[p.x, p.y, p.z] * WorldMatrix );

						effect.SetValue( "g_MaterialAmbientColor", System.Drawing.Color.Magenta.ToArgb() );	// !!!

						passes = effect.Begin(0);
						for (int pass = 0; pass < passes; pass++)
						{
							effect.BeginPass(pass);

							m_meshMk.DrawSubset(0);

							effect.EndPass();
						}
						effect.End();
					}
				}



				// -----------------------------------------------------------------
				// ŌɑłWɃ}[N\
				ArrayList	LastPosAL = this.getUpdate();

				if( 0 < LastPosAL.Count )
				{
					effect.SetValue("g_MaterialAmbientColor", System.Drawing.Color.Red.ToArgb() );
					
					Point LastPos = (Point)LastPosAL[0];

					effect.SetValue( "worldViewProjection",	m_GridMat[LastPos.x, LastPos.y, LastPos.z] * worldViewProjection );
					effect.SetValue( "GridWorldMatrix",     m_GridMat[LastPos.x, LastPos.y, LastPos.z] * WorldMatrix );
					
					passes = effect.Begin(0);
					for (int pass = 0; pass < passes; pass++)
					{
						effect.BeginPass(pass);

						m_meshLastMk.DrawSubset(0);

						effect.EndPass();
					}
					effect.End();
				}

			
			}
			catch(Exception e)
			{
				throw(e);
			}

		}



		public int XmlSave( string filename, string ^Cv, string ^Cv, int iAIx, int iAIx, int iAIx )
		{
			// 菇t@C(XML)o
			// ---------------------------------------------------------------------------
			/*
					http://ukamen.hp.infoseek.co.jp/Programming1/XMLText/index.htm

					WRITE ̃qg 
					1.GR[fBOw肷B@<?xml version="1.0" encoding="utf-8"?> 
						XmlTextWriter xtw = new System.Xml.XmlTextWriter(dialog.FileName System.Text.Encoding.UTF8); 
					2.CfgďoB 
						xtw.Formatting = Formatting.Indented; 
					3.Cfg̎w 
						xtw.Indentation = 4; 
					*/

			// WRITE
			XmlTextWriter xtw = new System.Xml.XmlTextWriter( filename, System.Text.Encoding.UTF8 ); 
			xtw.Formatting = Formatting.Indented;	// Cfgďo 

			// Starts a new document 
			xtw.WriteStartDocument();// o[W "1.0"  XML 錾 
			xtw.WriteComment("Rg2");	// Rg	

			// PersonalData
			xtw.WriteStartElement("root");	// Jn^O

			// [/{[hTCY/(AI) ȂǋLq^Oǉ
			// 1.{[hTCY
			// 3.͂߂
			// 2.vC[^Cv(vs)
			// AIvC[̏ꍇ:(l̏ꍇ)
			xtw.WriteComment("AIx:lvsAI AIx,AIx:AIvsAI");	// Rg	

			xtw.WriteStartElement("setup");	// Jn^O

			xtw.WriteAttributeString( "{[hTCY",	this.BoardSize.ToString()	);
			xtw.WriteAttributeString( "͂߂",	this.Rule.ToString()		);

			if     ( "HumanPlayer" == ^Cv && "HumanPlayer" == ^Cv )
				xtw.WriteAttributeString( "vC[^Cv", "l vs l" );
			else if( "HumanPlayer" == ^Cv && "AIPlayer"    == ^Cv )
				xtw.WriteAttributeString( "vC[^Cv", "l vs AI" );
			else if( "AIPlayer"    == ^Cv && "HumanPlayer" == ^Cv )
				xtw.WriteAttributeString( "vC[^Cv", "AI vs l" );
			else if( "AIPlayer"    == ^Cv && "AIPlayer"    == ^Cv )
				xtw.WriteAttributeString( "vC[^Cv", "AI vs AI" );

			xtw.WriteAttributeString( "AIx",		iAIx.ToString()			);

			xtw.WriteAttributeString( "AIx",		iAIx.ToString()			);
			xtw.WriteAttributeString( "AIx",		iAIx.ToString()			);


			xtw.WriteEndElement();			// I^O(setup)


			for( int i = 0; i < UpdateLog.Count; i++ )
			{
				ArrayList	al = (ArrayList)UpdateLog[i];


				if( al.Count != 0)	// pass̏ꍇAo͖
				{
					Disc		d = (Disc)al[0];

					xtw.WriteStartElement("GAME");	// Jn^O

					xtw.WriteAttributeString("turn", i.ToString() );	// w肵l̑

					xtw.WriteAttributeString("Player", d.F.ToString() );

					xtw.WriteAttributeString("x", d.x.ToString() );
					xtw.WriteAttributeString("y", d.y.ToString() );
					xtw.WriteAttributeString("z", d.z.ToString() );

					xtw.WriteEndElement();	// I^O(GAME)
				}
			}




			xtw.WriteEndElement();	// I^O(root)

			// EndDocument
			xtw.WriteEndDocument(); // JĂvf܂͑
			xtw.Close(); // ̃Xg[ъɂȂXg[܂B

			return 0;
		}
		// ==========================================================================
		// ==========================================================================


		/// <summary>
		/// Wʐݒ p=2/pɗא=1/ȊO=0
		/// </summary>
		private void initW()
		{
			float	BoardSize2 = this.iBOARD_SIZE / 2 + 0.5f;	// Wϊp̒l
			float	absX, absY, absZ;

			for( int x = 1; x <= BoardSize; x++ )
			{
				for( int y = 1; y <= BoardSize; y++ )
				{
					for( int z = 1; z <= BoardSize; z++ )
					{
						this.W[x,y,z] = 0;	// p=2 / pɗא=1 / ȊO=0

						// Board̋̎擾
						Vector3 v = new Vector3( x - BoardSize2, y - BoardSize2, z - BoardSize2 );

						// 1.p?
						// Βl
						absX = Math.Abs( v.X );
						absY = Math.Abs( v.Y );
						absZ = Math.Abs( v.Z );

						if( absX == corner && absY == corner && absZ == corner )	// c:ϊɊpɂȂW̒l
						{
							this.W[x,y,z] = 2;	// p=2 / pɗא=1 / ȊO=0
						}
						else
						{
							// 2.pɗא? 
							for( int i=0; i<8; i++ )
							{
								// pƑłƂ\ȍWƂ̊Ԃ̋߁A
								// pƗאڂ邩ǂ`FbNB
								Vector3 vc = new Vector3( p[i].X - v.X, p[i].Y - v.Y, p[i].Z - v.Z );

								if( vc.Length() <= (float)Math.Sqrt( 3 ) ) // 3
								{
									this.W[x,y,z] = 1;	// p=2 / pɗא=1 / ȊO=0
								}
							}
						}
					}
				}
			}
		}






















	}
}
